/* CDView.c generated by valac 0.36.4, the Vala compiler
 * generated from CDView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <noise.h>
#include <noise-core.h>
#include <granite.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_PLUGINS_TYPE_CD_VIEW (noise_plugins_cd_view_get_type ())
#define NOISE_PLUGINS_CD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_CD_VIEW, NoisePluginsCDView))
#define NOISE_PLUGINS_CD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_CD_VIEW, NoisePluginsCDViewClass))
#define NOISE_PLUGINS_IS_CD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_CD_VIEW))
#define NOISE_PLUGINS_IS_CD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_CD_VIEW))
#define NOISE_PLUGINS_CD_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_CD_VIEW, NoisePluginsCDViewClass))

typedef struct _NoisePluginsCDView NoisePluginsCDView;
typedef struct _NoisePluginsCDViewClass NoisePluginsCDViewClass;
typedef struct _NoisePluginsCDViewPrivate NoisePluginsCDViewPrivate;

#define NOISE_PLUGINS_TYPE_CD_VIEW_WRAPPER (noise_plugins_cd_view_wrapper_get_type ())
#define NOISE_PLUGINS_CD_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_CD_VIEW_WRAPPER, NoisePluginsCDViewWrapper))
#define NOISE_PLUGINS_CD_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_CD_VIEW_WRAPPER, NoisePluginsCDViewWrapperClass))
#define NOISE_PLUGINS_IS_CD_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_CD_VIEW_WRAPPER))
#define NOISE_PLUGINS_IS_CD_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_CD_VIEW_WRAPPER))
#define NOISE_PLUGINS_CD_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_CD_VIEW_WRAPPER, NoisePluginsCDViewWrapperClass))

typedef struct _NoisePluginsCDViewWrapper NoisePluginsCDViewWrapper;
typedef struct _NoisePluginsCDViewWrapperClass NoisePluginsCDViewWrapperClass;

#define NOISE_PLUGINS_TYPE_CD_ROM_DEVICE (noise_plugins_cd_rom_device_get_type ())
#define NOISE_PLUGINS_CD_ROM_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, NoisePluginsCDRomDevice))
#define NOISE_PLUGINS_CD_ROM_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, NoisePluginsCDRomDeviceClass))
#define NOISE_PLUGINS_IS_CD_ROM_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE))
#define NOISE_PLUGINS_IS_CD_ROM_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE))
#define NOISE_PLUGINS_CD_ROM_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, NoisePluginsCDRomDeviceClass))

typedef struct _NoisePluginsCDRomDevice NoisePluginsCDRomDevice;
typedef struct _NoisePluginsCDRomDeviceClass NoisePluginsCDRomDeviceClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NoisePluginsCDView {
	GtkGrid parent_instance;
	NoisePluginsCDViewPrivate * priv;
	NoisePluginsCDViewWrapper* cd_viewwrapper;
};

struct _NoisePluginsCDViewClass {
	GtkGridClass parent_class;
};

struct _NoisePluginsCDViewPrivate {
	NoisePluginsCDRomDevice* dev;
	GtkEventBox* main_event_box;
	GtkGrid* main_grid;
	NoiseWidgetsAlbumImage* album_image;
	GtkLabel* title;
	GtkLabel* author;
	NoiseStaticPlaylist* cd_playlist;
};


static gpointer noise_plugins_cd_view_parent_class = NULL;
static GType noise_plugins_cd_view_type_id = 0;

GType noise_plugins_cd_view_get_type (void) G_GNUC_CONST;
GType noise_plugins_cd_view_wrapper_get_type (void) G_GNUC_CONST;
GType noise_plugins_cd_rom_device_get_type (void) G_GNUC_CONST;
#define NOISE_PLUGINS_CD_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_PLUGINS_TYPE_CD_VIEW, NoisePluginsCDViewPrivate))
enum  {
	NOISE_PLUGINS_CD_VIEW_DUMMY_PROPERTY
};
NoisePluginsCDView* noise_plugins_cd_view_new (NoisePluginsCDRomDevice* d);
NoisePluginsCDView* noise_plugins_cd_view_construct (GType object_type, NoisePluginsCDRomDevice* d);
NoisePluginsCDViewWrapper* noise_plugins_cd_view_wrapper_new (NoiseStaticPlaylist* p);
NoisePluginsCDViewWrapper* noise_plugins_cd_view_wrapper_construct (GType object_type, NoiseStaticPlaylist* p);
void noise_plugins_cd_view_build_ui (NoisePluginsCDView* self);
void noise_plugins_cd_view_cd_initialised (NoisePluginsCDView* self);
static void _noise_plugins_cd_view_cd_initialised_noise_device_initialized (NoiseDevice* _sender, NoiseDevice* d, gpointer self);
static void __lambda4_ (NoisePluginsCDView* self);
gboolean noise_plugins_cd_rom_device_transfer_to_library (NoisePluginsCDRomDevice* self, GeeCollection* trans_list);
static void ___lambda4__gtk_button_clicked (GtkButton* _sender, gpointer self);
GeeCollection* noise_plugins_cd_rom_device_get_medias (NoisePluginsCDRomDevice* self);
static void noise_plugins_cd_view_load_cover (NoisePluginsCDView* self);
GtkLabel* noise_plugins_cd_view_create_title_label (NoisePluginsCDView* self, const gchar* title);
GtkLabel* noise_plugins_cd_view_create_length_label (NoisePluginsCDView* self, guint length);
static void noise_plugins_cd_view_finalize (GObject * obj);


static gpointer _g_object_ref0 (gpointer self) {
#line 44 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	return self ? g_object_ref (self) : NULL;
#line 132 "CDView.c"
}


static void _noise_plugins_cd_view_cd_initialised_noise_device_initialized (NoiseDevice* _sender, NoiseDevice* d, gpointer self) {
#line 50 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	noise_plugins_cd_view_cd_initialised ((NoisePluginsCDView*) self);
#line 139 "CDView.c"
}


NoisePluginsCDView* noise_plugins_cd_view_construct (GType object_type, NoisePluginsCDRomDevice* d) {
	NoisePluginsCDView * self = NULL;
	NoisePluginsCDRomDevice* _tmp0_;
	NoisePluginsCDRomDevice* _tmp1_;
	NoiseStaticPlaylist* _tmp2_;
	NoiseStaticPlaylist* _tmp3_;
	NoisePluginsCDViewWrapper* _tmp4_;
	NoisePluginsCDRomDevice* _tmp5_;
#line 43 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_return_val_if_fail (d != NULL, NULL);
#line 43 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	self = (NoisePluginsCDView*) g_object_new (object_type, NULL);
#line 44 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp0_ = d;
#line 44 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 44 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->dev);
#line 44 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	self->priv->dev = _tmp1_;
#line 45 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp2_ = noise_static_playlist_new ();
#line 45 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->cd_playlist);
#line 45 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	self->priv->cd_playlist = _tmp2_;
#line 46 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp3_ = self->priv->cd_playlist;
#line 46 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp4_ = noise_plugins_cd_view_wrapper_new (_tmp3_);
#line 46 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp4_);
#line 46 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->cd_viewwrapper);
#line 46 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	self->cd_viewwrapper = _tmp4_;
#line 48 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	noise_plugins_cd_view_build_ui (self);
#line 50 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp5_ = self->priv->dev;
#line 50 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_signal_connect_object ((NoiseDevice*) _tmp5_, "initialized", (GCallback) _noise_plugins_cd_view_cd_initialised_noise_device_initialized, self, 0);
#line 43 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	return self;
#line 187 "CDView.c"
}


NoisePluginsCDView* noise_plugins_cd_view_new (NoisePluginsCDRomDevice* d) {
#line 43 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	return noise_plugins_cd_view_construct (NOISE_PLUGINS_TYPE_CD_VIEW, d);
#line 194 "CDView.c"
}


static void __lambda4_ (NoisePluginsCDView* self) {
	NoisePluginsCDRomDevice* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	GeeArrayQueue* _tmp2_;
	GeeArrayQueue* _tmp3_;
#line 117 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp0_ = self->priv->dev;
#line 117 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp1_ = self->priv->cd_playlist;
#line 117 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp2_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp1_);
#line 117 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp3_ = _tmp2_;
#line 117 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	noise_plugins_cd_rom_device_transfer_to_library (_tmp0_, (GeeCollection*) _tmp3_);
#line 213 "CDView.c"
}


static void ___lambda4__gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 117 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	__lambda4_ ((NoisePluginsCDView*) self);
#line 220 "CDView.c"
}


void noise_plugins_cd_view_build_ui (NoisePluginsCDView* self) {
	GtkEventBox* _tmp0_;
	GtkGrid* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkStyleContext* _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	gboolean _tmp5_;
	NoiseWidgetsAlbumImage* _tmp6_;
	NoiseWidgetsAlbumImage* _tmp7_;
	GThemedIcon* _tmp8_;
	GThemedIcon* _tmp9_;
	NoiseWidgetsAlbumImage* _tmp10_;
	NoiseWidgetsAlbumImage* _tmp11_;
	NoiseWidgetsAlbumImage* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* fake_label_1 = NULL;
	GtkLabel* _tmp22_;
	GtkLabel* fake_label_2 = NULL;
	GtkLabel* _tmp23_;
	GtkLabel* fake_label_3 = NULL;
	GtkLabel* _tmp24_;
	GtkGrid* import_grid = NULL;
	GtkGrid* _tmp25_;
	GtkButton* import_button = NULL;
	GtkButton* _tmp26_;
	GtkGrid* _tmp27_;
	GtkGrid* _tmp28_;
	NoiseWidgetsAlbumImage* _tmp29_;
	GtkGrid* _tmp30_;
	GtkLabel* _tmp31_;
	GtkGrid* _tmp32_;
	GtkLabel* _tmp33_;
	GtkGrid* _tmp34_;
	NoisePluginsCDViewWrapper* _tmp35_;
	GtkGrid* _tmp36_;
	GtkGrid* _tmp37_;
	GtkEventBox* _tmp38_;
	GtkGrid* _tmp39_;
	GtkEventBox* _tmp40_;
	GtkGrid* _tmp41_;
	GtkGrid* _tmp42_;
	GtkGrid* _tmp43_;
	GtkGrid* _tmp44_;
#line 54 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_return_if_fail (self != NULL);
#line 56 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp0_ = (GtkEventBox*) gtk_event_box_new ();
#line 56 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp0_);
#line 56 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->main_event_box);
#line 56 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	self->priv->main_event_box = _tmp0_;
#line 57 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp1_ = (GtkGrid*) gtk_grid_new ();
#line 57 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp1_);
#line 57 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->main_grid);
#line 57 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	self->priv->main_grid = _tmp1_;
#line 60 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp2_ = self->priv->main_event_box;
#line 60 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 60 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_style_context_add_class (_tmp3_, GRANITE_STYLE_CLASS_CONTENT_VIEW);
#line 62 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp4_ = self->priv->cd_playlist;
#line 62 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp5_ = noise_playlist_is_empty ((NoisePlaylist*) _tmp4_);
#line 62 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	if (_tmp5_ == FALSE) {
#line 305 "CDView.c"
	}
#line 65 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp6_ = noise_widgets_album_image_new ();
#line 65 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp6_);
#line 65 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->album_image);
#line 65 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	self->priv->album_image = _tmp6_;
#line 66 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp7_ = self->priv->album_image;
#line 66 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp8_ = (GThemedIcon*) g_themed_icon_new ("albumart");
#line 66 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp9_ = _tmp8_;
#line 66 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_set ((GtkImage*) _tmp7_, "gicon", (GIcon*) _tmp9_, NULL);
#line 66 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (_tmp9_);
#line 67 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp10_ = self->priv->album_image;
#line 67 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
#line 68 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp11_ = self->priv->album_image;
#line 68 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp11_, GTK_ALIGN_CENTER);
#line 69 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp12_ = self->priv->album_image;
#line 69 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_misc_set_alignment ((GtkMisc*) _tmp12_, 0.5f, (gfloat) 1);
#line 71 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new ("");
#line 71 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp13_);
#line 71 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->title);
#line 71 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	self->priv->title = _tmp13_;
#line 72 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp14_ = self->priv->title;
#line 72 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_misc_set_alignment ((GtkMisc*) _tmp14_, 0.5f, (gfloat) 1);
#line 73 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp15_ = self->priv->title;
#line 73 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_label_set_justify (_tmp15_, GTK_JUSTIFY_CENTER);
#line 74 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp16_ = self->priv->title;
#line 74 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	granite_widgets_utils_apply_text_style_to_label (GRANITE_TEXT_STYLE_H2, _tmp16_);
#line 76 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp17_ = (GtkLabel*) gtk_label_new ("");
#line 76 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp17_);
#line 76 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->author);
#line 76 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	self->priv->author = _tmp17_;
#line 77 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp18_ = self->priv->author;
#line 77 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_misc_set_alignment ((GtkMisc*) _tmp18_, 0.5f, (gfloat) 1);
#line 78 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp19_ = self->priv->author;
#line 78 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_label_set_justify (_tmp19_, GTK_JUSTIFY_CENTER);
#line 79 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp20_ = self->priv->author;
#line 79 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, FALSE);
#line 80 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp21_ = self->priv->author;
#line 80 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	granite_widgets_utils_apply_text_style_to_label (GRANITE_TEXT_STYLE_H2, _tmp21_);
#line 82 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp22_ = (GtkLabel*) gtk_label_new ("");
#line 82 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp22_);
#line 82 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	fake_label_1 = _tmp22_;
#line 83 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) fake_label_1, TRUE);
#line 84 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_vexpand ((GtkWidget*) fake_label_1, TRUE);
#line 86 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp23_ = (GtkLabel*) gtk_label_new ("");
#line 86 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp23_);
#line 86 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	fake_label_2 = _tmp23_;
#line 87 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) fake_label_2, TRUE);
#line 88 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_vexpand ((GtkWidget*) fake_label_2, TRUE);
#line 90 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp24_ = (GtkLabel*) gtk_label_new ("");
#line 90 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp24_);
#line 90 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	fake_label_3 = _tmp24_;
#line 91 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) fake_label_3, TRUE);
#line 93 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp25_ = (GtkGrid*) gtk_grid_new ();
#line 93 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp25_);
#line 93 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	import_grid = _tmp25_;
#line 94 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp26_ = (GtkButton*) gtk_button_new_with_label (_ ("Import"));
#line 94 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp26_);
#line 94 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	import_button = _tmp26_;
#line 95 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_button_set_alignment (import_button, (gfloat) 1, (gfloat) 0);
#line 96 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_attach (import_grid, (GtkWidget*) fake_label_3, 0, 0, 1, 1);
#line 97 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_attach (import_grid, (GtkWidget*) import_button, 1, 0, 1, 1);
#line 99 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp27_ = self->priv->main_grid;
#line 99 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_attach (_tmp27_, (GtkWidget*) fake_label_1, 0, 0, 1, 7);
#line 100 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp28_ = self->priv->main_grid;
#line 100 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp29_ = self->priv->album_image;
#line 100 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_attach (_tmp28_, (GtkWidget*) _tmp29_, 1, 3, 1, 1);
#line 101 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp30_ = self->priv->main_grid;
#line 101 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp31_ = self->priv->title;
#line 101 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 2, 2, 1, 1);
#line 102 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp32_ = self->priv->main_grid;
#line 102 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp33_ = self->priv->author;
#line 102 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_attach (_tmp32_, (GtkWidget*) _tmp33_, 3, 2, 1, 1);
#line 103 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp34_ = self->priv->main_grid;
#line 103 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp35_ = self->cd_viewwrapper;
#line 103 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp35_, 2, 3, 2, 1);
#line 104 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp36_ = self->priv->main_grid;
#line 104 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_attach (_tmp36_, (GtkWidget*) import_grid, 3, 4, 1, 1);
#line 105 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp37_ = self->priv->main_grid;
#line 105 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_attach (_tmp37_, (GtkWidget*) fake_label_2, 4, 0, 1, 7);
#line 107 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp38_ = self->priv->main_event_box;
#line 107 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp39_ = self->priv->main_grid;
#line 107 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 108 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp40_ = self->priv->main_event_box;
#line 108 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp40_, 0, 0, 1, 1);
#line 112 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp41_ = self->priv->main_grid;
#line 112 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp41_, TRUE);
#line 113 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp42_ = self->priv->main_grid;
#line 113 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_set_row_spacing (_tmp42_, (guint) 6);
#line 114 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp43_ = self->priv->main_grid;
#line 114 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_grid_set_column_spacing (_tmp43_, (guint) 12);
#line 115 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp44_ = self->priv->main_grid;
#line 115 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp44_, 12);
#line 117 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_signal_connect_object (import_button, "clicked", (GCallback) ___lambda4__gtk_button_clicked, self, 0);
#line 119 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 54 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (import_button);
#line 54 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (import_grid);
#line 54 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (fake_label_3);
#line 54 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (fake_label_2);
#line 54 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (fake_label_1);
#line 503 "CDView.c"
}


void noise_plugins_cd_view_cd_initialised (NoisePluginsCDView* self) {
	NoiseStaticPlaylist* _tmp0_;
	NoisePluginsCDRomDevice* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	gboolean _tmp5_;
#line 122 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_return_if_fail (self != NULL);
#line 123 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp0_ = self->priv->cd_playlist;
#line 123 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp1_ = self->priv->dev;
#line 123 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp2_ = noise_plugins_cd_rom_device_get_medias (_tmp1_);
#line 123 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp3_ = _tmp2_;
#line 123 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	noise_playlist_add_medias ((NoisePlaylist*) _tmp0_, _tmp3_);
#line 123 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (_tmp3_);
#line 124 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp4_ = self->priv->cd_playlist;
#line 124 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp5_ = noise_playlist_is_empty ((NoisePlaylist*) _tmp4_);
#line 124 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	if (_tmp5_ == FALSE) {
#line 534 "CDView.c"
		NoiseMedia* m = NULL;
		NoiseStaticPlaylist* _tmp6_;
		GeeArrayQueue* _tmp7_;
		GeeArrayQueue* _tmp8_;
		gpointer _tmp9_;
		GtkLabel* _tmp10_;
		NoiseMedia* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		GtkLabel* _tmp14_;
		NoiseMedia* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 125 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp6_ = self->priv->cd_playlist;
#line 125 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp7_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp6_);
#line 125 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp8_ = _tmp7_;
#line 125 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp9_ = gee_abstract_queue_peek ((GeeAbstractQueue*) _tmp8_);
#line 125 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		m = (NoiseMedia*) _tmp9_;
#line 126 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp10_ = self->priv->author;
#line 126 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp11_ = m;
#line 126 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp12_ = noise_media_get_display_album_artist (_tmp11_, TRUE);
#line 126 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp13_ = _tmp12_;
#line 126 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		gtk_label_set_markup (_tmp10_, _tmp13_);
#line 126 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_g_free0 (_tmp13_);
#line 127 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp14_ = self->priv->title;
#line 127 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp15_ = m;
#line 127 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp16_ = noise_media_get_display_album (_tmp15_);
#line 127 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp17_ = _tmp16_;
#line 127 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		gtk_label_set_markup (_tmp14_, _tmp17_);
#line 127 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_g_free0 (_tmp17_);
#line 128 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		noise_plugins_cd_view_load_cover (self);
#line 124 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_g_object_unref0 (m);
#line 586 "CDView.c"
	}
#line 130 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 590 "CDView.c"
}


static void noise_plugins_cd_view_load_cover (NoisePluginsCDView* self) {
	GIcon* cover_icon = NULL;
	NoiseStaticPlaylist* _tmp0_;
	GeeArrayQueue* _tmp1_;
	GeeArrayQueue* _tmp2_;
	gpointer _tmp3_;
	NoiseMedia* _tmp4_;
	NoiseAlbum* _tmp5_;
	NoiseAlbum* _tmp6_;
	GIcon* _tmp7_;
	GIcon* _tmp8_;
	GIcon* _tmp9_;
	GIcon* _tmp10_;
	GIcon* _tmp11_;
#line 133 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_return_if_fail (self != NULL);
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp0_ = self->priv->cd_playlist;
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp1_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp0_);
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp2_ = _tmp1_;
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp3_ = gee_abstract_queue_peek ((GeeAbstractQueue*) _tmp2_);
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp4_ = (NoiseMedia*) _tmp3_;
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp5_ = noise_media_get_album_info (_tmp4_);
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp6_ = _tmp5_;
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp7_ = noise_album_get_cover_icon (_tmp6_);
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp8_ = _tmp7_;
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp10_ = _tmp9_;
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (_tmp4_);
#line 134 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	cover_icon = _tmp10_;
#line 135 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp11_ = cover_icon;
#line 135 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	if (_tmp11_ != NULL) {
#line 640 "CDView.c"
		NoiseWidgetsAlbumImage* _tmp12_;
		GIcon* _tmp13_;
#line 136 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp12_ = self->priv->album_image;
#line 136 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		_tmp13_ = cover_icon;
#line 136 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
		g_object_set ((GtkImage*) _tmp12_, "gicon", _tmp13_, NULL);
#line 649 "CDView.c"
	}
#line 133 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (cover_icon);
#line 653 "CDView.c"
}


GtkLabel* noise_plugins_cd_view_create_title_label (NoisePluginsCDView* self, const gchar* title) {
	GtkLabel* result = NULL;
	GtkLabel* label = NULL;
	const gchar* _tmp0_;
	GtkLabel* _tmp1_;
#line 140 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 140 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 141 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp0_ = title;
#line 141 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
#line 141 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp1_);
#line 141 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	label = _tmp1_;
#line 142 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_halign ((GtkWidget*) label, GTK_ALIGN_START);
#line 143 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_label_set_justify (label, GTK_JUSTIFY_LEFT);
#line 144 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_misc_set_alignment ((GtkMisc*) label, (gfloat) 0, (gfloat) 0);
#line 145 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) label, TRUE);
#line 146 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	result = label;
#line 146 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	return result;
#line 686 "CDView.c"
}


GtkLabel* noise_plugins_cd_view_create_length_label (NoisePluginsCDView* self, guint length) {
	GtkLabel* result = NULL;
	GtkLabel* label = NULL;
	guint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
#line 149 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp0_ = length;
#line 150 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp1_ = noise_time_utils_pretty_length_from_ms ((guint64) _tmp0_);
#line 150 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp2_ = _tmp1_;
#line 150 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
#line 150 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_object_ref_sink (_tmp3_);
#line 150 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_tmp4_ = _tmp3_;
#line 150 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_free0 (_tmp2_);
#line 150 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	label = _tmp4_;
#line 151 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	gtk_label_set_justify (label, GTK_JUSTIFY_RIGHT);
#line 152 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	result = label;
#line 152 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	return result;
#line 722 "CDView.c"
}


static void noise_plugins_cd_view_class_init (NoisePluginsCDViewClass * klass) {
#line 29 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	noise_plugins_cd_view_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	g_type_class_add_private (klass, sizeof (NoisePluginsCDViewPrivate));
#line 29 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_cd_view_finalize;
#line 733 "CDView.c"
}


static void noise_plugins_cd_view_instance_init (NoisePluginsCDView * self) {
#line 29 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	self->priv = NOISE_PLUGINS_CD_VIEW_GET_PRIVATE (self);
#line 740 "CDView.c"
}


static void noise_plugins_cd_view_finalize (GObject * obj) {
	NoisePluginsCDView * self;
#line 29 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_CD_VIEW, NoisePluginsCDView);
#line 30 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->dev);
#line 32 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->main_event_box);
#line 33 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->main_grid);
#line 35 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->album_image);
#line 37 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->title);
#line 38 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->author);
#line 40 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->priv->cd_playlist);
#line 41 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	_g_object_unref0 (self->cd_viewwrapper);
#line 29 "/builddir/build/BUILD/music-0.4.1/plugins/Devices/CDRom/CDView.vala"
	G_OBJECT_CLASS (noise_plugins_cd_view_parent_class)->finalize (obj);
#line 766 "CDView.c"
}


GType noise_plugins_cd_view_get_type (void) {
	return noise_plugins_cd_view_type_id;
}


GType noise_plugins_cd_view_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsCDViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_cd_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsCDView), 0, (GInstanceInitFunc) noise_plugins_cd_view_instance_init, NULL };
	noise_plugins_cd_view_type_id = g_type_module_register_type (module, gtk_grid_get_type (), "NoisePluginsCDView", &g_define_type_info, 0);
	return noise_plugins_cd_view_type_id;
}



