/* SyncWarningDialog.c generated by valac 0.36.4, the Vala compiler
 * generated from SyncWarningDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <noise-core.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_SYNC_WARNING_DIALOG (noise_sync_warning_dialog_get_type ())
#define NOISE_SYNC_WARNING_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialog))
#define NOISE_SYNC_WARNING_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialogClass))
#define NOISE_IS_SYNC_WARNING_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SYNC_WARNING_DIALOG))
#define NOISE_IS_SYNC_WARNING_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SYNC_WARNING_DIALOG))
#define NOISE_SYNC_WARNING_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialogClass))

typedef struct _NoiseSyncWarningDialog NoiseSyncWarningDialog;
typedef struct _NoiseSyncWarningDialogClass NoiseSyncWarningDialogClass;
typedef struct _NoiseSyncWarningDialogPrivate NoiseSyncWarningDialogPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NoiseSyncWarningDialog {
	GtkWindow parent_instance;
	NoiseSyncWarningDialogPrivate * priv;
};

struct _NoiseSyncWarningDialogClass {
	GtkWindowClass parent_class;
};

struct _NoiseSyncWarningDialogPrivate {
	NoiseDevice* d;
	GeeTreeSet* to_sync;
	GeeTreeSet* to_remove;
	GtkBox* content;
	GtkBox* padding;
	GtkButton* importMedias;
	GtkButton* sync;
	GtkButton* cancel;
};


static gpointer noise_sync_warning_dialog_parent_class = NULL;

GType noise_sync_warning_dialog_get_type (void) G_GNUC_CONST;
#define NOISE_SYNC_WARNING_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialogPrivate))
enum  {
	NOISE_SYNC_WARNING_DIALOG_DUMMY_PROPERTY
};
NoiseSyncWarningDialog* noise_sync_warning_dialog_new (NoiseDevice* d, GeeCollection* to_sync, GeeCollection* removed);
NoiseSyncWarningDialog* noise_sync_warning_dialog_construct (GType object_type, NoiseDevice* d, GeeCollection* to_sync, GeeCollection* removed);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
void noise_sync_warning_dialog_importMediasClicked (NoiseSyncWarningDialog* self);
static void _noise_sync_warning_dialog_importMediasClicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
void noise_sync_warning_dialog_syncClicked (NoiseSyncWarningDialog* self);
static void _noise_sync_warning_dialog_syncClicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void __lambda127_ (NoiseSyncWarningDialog* self);
static void ___lambda127__gtk_button_clicked (GtkButton* _sender, gpointer self);
void noise_sync_warning_dialog_file_operations_started (NoiseSyncWarningDialog* self);
static void _noise_sync_warning_dialog_file_operations_started_noise_library_file_operations_started (NoiseLibrary* _sender, gpointer self);
void noise_sync_warning_dialog_file_operations_done (NoiseSyncWarningDialog* self);
static void _noise_sync_warning_dialog_file_operations_done_noise_library_file_operations_done (NoiseLibrary* _sender, gpointer self);
static void noise_sync_warning_dialog_finalize (GObject * obj);


static gpointer _g_object_ref0 (gpointer self) {
#line 42 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 115 "SyncWarningDialog.c"
}


static void _noise_sync_warning_dialog_importMediasClicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 111 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	noise_sync_warning_dialog_importMediasClicked ((NoiseSyncWarningDialog*) self);
#line 122 "SyncWarningDialog.c"
}


static void _noise_sync_warning_dialog_syncClicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 112 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	noise_sync_warning_dialog_syncClicked ((NoiseSyncWarningDialog*) self);
#line 129 "SyncWarningDialog.c"
}


static void __lambda127_ (NoiseSyncWarningDialog* self) {
#line 114 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 136 "SyncWarningDialog.c"
}


static void ___lambda127__gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 113 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	__lambda127_ ((NoiseSyncWarningDialog*) self);
#line 143 "SyncWarningDialog.c"
}


static void _noise_sync_warning_dialog_file_operations_started_noise_library_file_operations_started (NoiseLibrary* _sender, gpointer self) {
#line 117 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	noise_sync_warning_dialog_file_operations_started ((NoiseSyncWarningDialog*) self);
#line 150 "SyncWarningDialog.c"
}


static void _noise_sync_warning_dialog_file_operations_done_noise_library_file_operations_done (NoiseLibrary* _sender, gpointer self) {
#line 118 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	noise_sync_warning_dialog_file_operations_done ((NoiseSyncWarningDialog*) self);
#line 157 "SyncWarningDialog.c"
}


NoiseSyncWarningDialog* noise_sync_warning_dialog_construct (GType object_type, NoiseDevice* d, GeeCollection* to_sync, GeeCollection* removed) {
	NoiseSyncWarningDialog * self = NULL;
	NoiseDevice* _tmp0_;
	NoiseDevice* _tmp1_;
	GeeTreeSet* _tmp2_;
	GeeCollection* _tmp3_;
	GeeTreeSet* _tmp4_;
	GeeCollection* _tmp5_;
	NoiseLibraryWindow* _tmp6_;
	NoiseLibraryWindow* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	GtkImage* warning = NULL;
	GtkImage* _tmp10_;
	GtkLabel* title = NULL;
	GtkLabel* _tmp11_;
	GtkLabel* info = NULL;
	GtkLabel* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	gchar* info_text = NULL;
	NoiseDevice* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GtkLabel* _tmp30_;
	const gchar* _tmp31_;
	gchar* title_text = NULL;
	gchar* _tmp32_;
	GeeTreeSet* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	gchar* MARKUP_TEMPLATE = NULL;
	gchar* _tmp47_;
	gchar* title_string = NULL;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	GtkLabel* _tmp53_;
	GtkButton* _tmp54_;
	NoiseLibrariesManager* _tmp55_;
	NoiseLibrary* _tmp56_;
	gboolean _tmp57_;
	GtkButton* _tmp58_;
	NoiseLibrariesManager* _tmp59_;
	NoiseLibrary* _tmp60_;
	gboolean _tmp61_;
	GtkBox* information = NULL;
	GtkBox* _tmp62_;
	GtkBox* information_text = NULL;
	GtkBox* _tmp63_;
	GtkImage* _tmp64_;
	GtkLabel* _tmp65_;
	GtkLabel* _tmp66_;
	GtkButtonBox* bottomButtons = NULL;
	GtkButtonBox* _tmp67_;
	GtkButton* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	GtkBox* _tmp71_;
	GtkBox* _tmp72_;
	GtkBox* _tmp73_;
	GtkBox* _tmp74_;
	GtkButton* _tmp75_;
	GtkButton* _tmp76_;
	GtkButton* _tmp77_;
	NoiseLibrariesManager* _tmp78_;
	NoiseLibrary* _tmp79_;
	NoiseLibrariesManager* _tmp80_;
	NoiseLibrary* _tmp81_;
	GtkBox* _tmp82_;
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_return_val_if_fail (d != NULL, NULL);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_return_val_if_fail (to_sync != NULL, NULL);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_return_val_if_fail (removed != NULL, NULL);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	self = (NoiseSyncWarningDialog*) g_object_new (object_type, NULL);
#line 42 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = d;
#line 42 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 42 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->d);
#line 42 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	self->priv->d = _tmp1_;
#line 43 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp2_ = self->priv->to_sync;
#line 43 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp3_ = to_sync;
#line 43 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gee_collection_add_all ((GeeCollection*) _tmp2_, _tmp3_);
#line 44 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp4_ = self->priv->to_remove;
#line 44 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp5_ = removed;
#line 44 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gee_collection_add_all ((GeeCollection*) _tmp4_, _tmp5_);
#line 48 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_window_set_type_hint ((GtkWindow*) self, GDK_WINDOW_TYPE_HINT_DIALOG);
#line 49 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 50 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp6_ = noise_app_get_main_window ();
#line 50 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp7_ = _tmp6_;
#line 50 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, (GtkWindow*) _tmp7_);
#line 51 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_window_set_destroy_with_parent ((GtkWindow*) self, TRUE);
#line 53 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_window_set_default_size ((GtkWindow*) self, 475, -1);
#line 54 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 56 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp8_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 10);
#line 56 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_object_ref_sink (_tmp8_);
#line 56 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->content);
#line 56 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	self->priv->content = _tmp8_;
#line 57 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp9_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 20);
#line 57 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_object_ref_sink (_tmp9_);
#line 57 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->padding);
#line 57 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	self->priv->padding = _tmp9_;
#line 60 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name ("dialog-error", GTK_ICON_SIZE_DIALOG);
#line 60 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_object_ref_sink (_tmp10_);
#line 60 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	warning = _tmp10_;
#line 61 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new ("");
#line 61 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_object_ref_sink (_tmp11_);
#line 61 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	title = _tmp11_;
#line 62 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp12_ = (GtkLabel*) gtk_label_new ("");
#line 62 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_object_ref_sink (_tmp12_);
#line 62 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	info = _tmp12_;
#line 63 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp13_ = (GtkButton*) gtk_button_new_with_label (_ ("Import media to Library"));
#line 63 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_object_ref_sink (_tmp13_);
#line 63 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->importMedias);
#line 63 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	self->priv->importMedias = _tmp13_;
#line 64 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp14_ = (GtkButton*) gtk_button_new_with_label (_ ("Continue Syncing"));
#line 64 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_object_ref_sink (_tmp14_);
#line 64 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->sync);
#line 64 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	self->priv->sync = _tmp14_;
#line 65 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp15_ = (GtkButton*) gtk_button_new_with_label (_ ("Stop Syncing"));
#line 65 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_object_ref_sink (_tmp15_);
#line 65 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->cancel);
#line 65 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	self->priv->cancel = _tmp15_;
#line 68 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp16_ = title;
#line 68 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp16_, GTK_ALIGN_START);
#line 69 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp17_ = info;
#line 69 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp17_, GTK_ALIGN_START);
#line 71 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp18_ = info;
#line 71 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_label_set_line_wrap (_tmp18_, TRUE);
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp19_ = d;
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp20_ = noise_device_getDisplayName (_tmp19_);
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp21_ = _tmp20_;
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp22_ = g_markup_escape_text (_tmp21_, (gssize) -1);
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp23_ = _tmp22_;
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp24_ = g_strconcat ("<b>", _tmp23_, NULL);
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp25_ = _tmp24_;
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp26_ = g_strconcat (_tmp25_, "</b>", NULL);
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp27_ = _tmp26_;
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp28_ = g_strdup_printf (_ ("If you continue to sync, media will be removed from %s since they are " \
"not on the sync list. Would you like to import them to your library fi" \
"rst?"), _tmp27_);
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp29_ = _tmp28_;
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp27_);
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp25_);
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp23_);
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp21_);
#line 72 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	info_text = _tmp29_;
#line 73 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp30_ = info;
#line 73 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp31_ = info_text;
#line 73 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_label_set_markup (_tmp30_, _tmp31_);
#line 76 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp32_ = g_strdup ("");
#line 76 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	title_text = _tmp32_;
#line 77 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp33_ = self->priv->to_remove;
#line 77 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
#line 77 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp35_ = _tmp34_;
#line 77 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	if (_tmp35_ > 1) {
#line 409 "SyncWarningDialog.c"
		GeeTreeSet* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		NoiseDevice* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
#line 78 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_tmp36_ = self->priv->to_remove;
#line 78 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 78 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_tmp38_ = _tmp37_;
#line 78 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_tmp39_ = d;
#line 78 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_tmp40_ = noise_device_getDisplayName (_tmp39_);
#line 78 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_tmp41_ = _tmp40_;
#line 78 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_tmp42_ = g_strdup_printf (_ ("Sync will remove %i items from %s"), _tmp38_, _tmp41_);
#line 78 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_g_free0 (title_text);
#line 78 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		title_text = _tmp42_;
#line 78 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_g_free0 (_tmp41_);
#line 437 "SyncWarningDialog.c"
	} else {
		NoiseDevice* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
#line 81 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_tmp43_ = d;
#line 81 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_tmp44_ = noise_device_getDisplayName (_tmp43_);
#line 81 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_tmp45_ = _tmp44_;
#line 81 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_tmp46_ = g_strdup_printf (_ ("Sync will remove 1 item from %s"), _tmp45_);
#line 81 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_g_free0 (title_text);
#line 81 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		title_text = _tmp46_;
#line 81 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
		_g_free0 (_tmp45_);
#line 457 "SyncWarningDialog.c"
	}
#line 84 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp47_ = g_strdup ("<span weight=\"bold\" size=\"larger\">%s</span>");
#line 84 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	MARKUP_TEMPLATE = _tmp47_;
#line 85 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp48_ = title_text;
#line 85 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp49_ = g_markup_escape_text (_tmp48_, (gssize) -1);
#line 85 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp50_ = _tmp49_;
#line 85 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp51_ = g_strdup_printf (MARKUP_TEMPLATE, _tmp50_);
#line 85 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp52_ = _tmp51_;
#line 85 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp50_);
#line 85 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	title_string = _tmp52_;
#line 86 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp53_ = title;
#line 86 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_label_set_markup (_tmp53_, title_string);
#line 88 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp54_ = self->priv->importMedias;
#line 88 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp55_ = noise_libraries_manager;
#line 88 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp56_ = _tmp55_->local_library;
#line 88 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp57_ = noise_library_doing_file_operations (_tmp56_);
#line 88 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp54_, !_tmp57_);
#line 89 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp58_ = self->priv->sync;
#line 89 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp59_ = noise_libraries_manager;
#line 89 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp60_ = _tmp59_->local_library;
#line 89 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp61_ = noise_library_doing_file_operations (_tmp60_);
#line 89 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp58_, !_tmp61_);
#line 92 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp62_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 92 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_object_ref_sink (_tmp62_);
#line 92 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	information = _tmp62_;
#line 93 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp63_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 93 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_object_ref_sink (_tmp63_);
#line 93 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	information_text = _tmp63_;
#line 94 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp64_ = warning;
#line 94 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_box_pack_start (information, (GtkWidget*) _tmp64_, FALSE, FALSE, (guint) 10);
#line 95 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp65_ = title;
#line 95 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_box_pack_start (information_text, (GtkWidget*) _tmp65_, FALSE, TRUE, (guint) 10);
#line 96 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp66_ = info;
#line 96 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_box_pack_start (information_text, (GtkWidget*) _tmp66_, FALSE, TRUE, (guint) 0);
#line 97 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_box_pack_start (information, (GtkWidget*) information_text, TRUE, TRUE, (guint) 10);
#line 99 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp67_ = (GtkButtonBox*) gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);
#line 99 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_object_ref_sink (_tmp67_);
#line 99 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	bottomButtons = _tmp67_;
#line 100 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_button_box_set_layout (bottomButtons, GTK_BUTTONBOX_END);
#line 101 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp68_ = self->priv->importMedias;
#line 101 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_box_pack_end ((GtkBox*) bottomButtons, (GtkWidget*) _tmp68_, FALSE, FALSE, (guint) 0);
#line 102 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp69_ = self->priv->sync;
#line 102 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_box_pack_end ((GtkBox*) bottomButtons, (GtkWidget*) _tmp69_, FALSE, FALSE, (guint) 0);
#line 103 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp70_ = self->priv->cancel;
#line 103 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_box_pack_end ((GtkBox*) bottomButtons, (GtkWidget*) _tmp70_, FALSE, FALSE, (guint) 10);
#line 104 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_box_set_spacing ((GtkBox*) bottomButtons, 10);
#line 106 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp71_ = self->priv->content;
#line 106 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_box_pack_start (_tmp71_, (GtkWidget*) information, FALSE, TRUE, (guint) 0);
#line 107 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp72_ = self->priv->content;
#line 107 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_box_pack_start (_tmp72_, (GtkWidget*) bottomButtons, FALSE, TRUE, (guint) 10);
#line 109 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp73_ = self->priv->padding;
#line 109 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp74_ = self->priv->content;
#line 109 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_box_pack_start (_tmp73_, (GtkWidget*) _tmp74_, TRUE, TRUE, (guint) 10);
#line 111 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp75_ = self->priv->importMedias;
#line 111 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_signal_connect_object (_tmp75_, "clicked", (GCallback) _noise_sync_warning_dialog_importMediasClicked_gtk_button_clicked, self, 0);
#line 112 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp76_ = self->priv->sync;
#line 112 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_signal_connect_object (_tmp76_, "clicked", (GCallback) _noise_sync_warning_dialog_syncClicked_gtk_button_clicked, self, 0);
#line 113 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp77_ = self->priv->cancel;
#line 113 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_signal_connect_object (_tmp77_, "clicked", (GCallback) ___lambda127__gtk_button_clicked, self, 0);
#line 117 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp78_ = noise_libraries_manager;
#line 117 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp79_ = _tmp78_->local_library;
#line 117 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_signal_connect_object (_tmp79_, "file-operations-started", (GCallback) _noise_sync_warning_dialog_file_operations_started_noise_library_file_operations_started, self, 0);
#line 118 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp80_ = noise_libraries_manager;
#line 118 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp81_ = _tmp80_->local_library;
#line 118 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_signal_connect_object (_tmp81_, "file-operations-done", (GCallback) _noise_sync_warning_dialog_file_operations_done_noise_library_file_operations_done, self, 0);
#line 120 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp82_ = self->priv->padding;
#line 120 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp82_);
#line 121 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (bottomButtons);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (information_text);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (information);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (title_string);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (MARKUP_TEMPLATE);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (title_text);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (info_text);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (info);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (title);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (warning);
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	return self;
#line 615 "SyncWarningDialog.c"
}


NoiseSyncWarningDialog* noise_sync_warning_dialog_new (NoiseDevice* d, GeeCollection* to_sync, GeeCollection* removed) {
#line 41 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	return noise_sync_warning_dialog_construct (NOISE_TYPE_SYNC_WARNING_DIALOG, d, to_sync, removed);
#line 622 "SyncWarningDialog.c"
}


void noise_sync_warning_dialog_importMediasClicked (NoiseSyncWarningDialog* self) {
	NoiseLibrariesManager* _tmp0_;
	GeeTreeSet* _tmp1_;
#line 124 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_return_if_fail (self != NULL);
#line 125 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = noise_libraries_manager;
#line 125 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp1_ = self->priv->to_remove;
#line 125 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	noise_libraries_manager_transfer_to_local_library (_tmp0_, (GeeCollection*) _tmp1_);
#line 128 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 639 "SyncWarningDialog.c"
}


void noise_sync_warning_dialog_syncClicked (NoiseSyncWarningDialog* self) {
	NoiseDevice* _tmp0_;
#line 131 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_return_if_fail (self != NULL);
#line 132 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = self->priv->d;
#line 132 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	noise_device_synchronize (_tmp0_);
#line 134 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 653 "SyncWarningDialog.c"
}


void noise_sync_warning_dialog_file_operations_done (NoiseSyncWarningDialog* self) {
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
#line 137 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_return_if_fail (self != NULL);
#line 138 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = self->priv->importMedias;
#line 138 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
#line 139 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp1_ = self->priv->sync;
#line 139 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, TRUE);
#line 670 "SyncWarningDialog.c"
}


void noise_sync_warning_dialog_file_operations_started (NoiseSyncWarningDialog* self) {
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
#line 142 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_return_if_fail (self != NULL);
#line 143 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = self->priv->importMedias;
#line 143 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 144 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp1_ = self->priv->sync;
#line 144 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 687 "SyncWarningDialog.c"
}


static void noise_sync_warning_dialog_class_init (NoiseSyncWarningDialogClass * klass) {
#line 29 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	noise_sync_warning_dialog_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	g_type_class_add_private (klass, sizeof (NoiseSyncWarningDialogPrivate));
#line 29 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_sync_warning_dialog_finalize;
#line 698 "SyncWarningDialog.c"
}


static void noise_sync_warning_dialog_instance_init (NoiseSyncWarningDialog * self) {
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
#line 29 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	self->priv = NOISE_SYNC_WARNING_DIALOG_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = gee_tree_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 31 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	self->priv->to_sync = _tmp0_;
#line 32 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_tmp1_ = gee_tree_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 32 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	self->priv->to_remove = _tmp1_;
#line 715 "SyncWarningDialog.c"
}


static void noise_sync_warning_dialog_finalize (GObject * obj) {
	NoiseSyncWarningDialog * self;
#line 29 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialog);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->d);
#line 31 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->to_sync);
#line 32 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->to_remove);
#line 34 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->content);
#line 35 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->padding);
#line 37 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->importMedias);
#line 38 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->sync);
#line 39 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->cancel);
#line 29 "/builddir/build/BUILD/music-0.4.1/src/Dialogs/SyncWarningDialog.vala"
	G_OBJECT_CLASS (noise_sync_warning_dialog_parent_class)->finalize (obj);
#line 741 "SyncWarningDialog.c"
}


GType noise_sync_warning_dialog_get_type (void) {
	static volatile gsize noise_sync_warning_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&noise_sync_warning_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSyncWarningDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_sync_warning_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSyncWarningDialog), 0, (GInstanceInitFunc) noise_sync_warning_dialog_instance_init, NULL };
		GType noise_sync_warning_dialog_type_id;
		noise_sync_warning_dialog_type_id = g_type_register_static (gtk_window_get_type (), "NoiseSyncWarningDialog", &g_define_type_info, 0);
		g_once_init_leave (&noise_sync_warning_dialog_type_id__volatile, noise_sync_warning_dialog_type_id);
	}
	return noise_sync_warning_dialog_type_id__volatile;
}



