/* PlaybackManager.c generated by valac 0.36.4, the Vala compiler
 * generated from PlaybackManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <noise-core.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <glib/gi18n-lib.h>


#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;
typedef struct _NoisePlaybackManagerPrivate NoisePlaybackManagerPrivate;

#define NOISE_TYPE_HISTORY_PLAYLIST (noise_history_playlist_get_type ())
#define NOISE_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylist))
#define NOISE_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))
#define NOISE_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))

typedef struct _NoiseHistoryPlaylist NoiseHistoryPlaylist;
typedef struct _NoiseHistoryPlaylistClass NoiseHistoryPlaylistClass;

#define NOISE_TYPE_STREAMER (noise_streamer_get_type ())
#define NOISE_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STREAMER, NoiseStreamer))
#define NOISE_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STREAMER, NoiseStreamerClass))
#define NOISE_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STREAMER))
#define NOISE_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STREAMER))
#define NOISE_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STREAMER, NoiseStreamerClass))

typedef struct _NoiseStreamer NoiseStreamer;
typedef struct _NoiseStreamerClass NoiseStreamerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NOISE_PLAYBACK_MANAGER_CURRENT_CLEARED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_MEDIA_QUEUED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_LAST_SIGNAL
};
static guint noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_LAST_SIGNAL] = {0};

struct _NoisePlaybackManager {
	GObject parent_instance;
	NoisePlaybackManagerPrivate * priv;
	NoiseStaticPlaylist* queue_playlist;
	NoiseHistoryPlaylist* history_playlist;
	gint next_gapless_id;
	NoiseStreamer* file_player;
	NoisePlayback* player;
};

struct _NoisePlaybackManagerClass {
	GObjectClass parent_class;
};

struct _NoisePlaybackManagerPrivate {
	GeeTreeSet* playbacks;
	GRecMutex __lock_playbacks;
	GeeHashMap* _current;
	GeeHashMap* _current_shuffled;
	gint _current_index;
	gint _current_shuffled_index;
	gboolean _playing;
	gdouble saved_volume;
	gboolean _playing_queued_song;
	NoiseMedia* _current_media;
};

struct _Block8Data {
	int _ref_count_;
	NoisePlaybackManager* self;
	NoiseMedia* m;
};


static gpointer noise_playback_manager_parent_class = NULL;
static NoisePlayerIface * noise_playback_manager_noise_player_parent_iface = NULL;

GType noise_playback_manager_get_type (void) G_GNUC_CONST;
GType noise_history_playlist_get_type (void) G_GNUC_CONST;
GType noise_streamer_get_type (void) G_GNUC_CONST;
#define NOISE_PLAYBACK_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerPrivate))
enum  {
	NOISE_PLAYBACK_MANAGER_DUMMY_PROPERTY,
	NOISE_PLAYBACK_MANAGER_LIBRARY,
	NOISE_PLAYBACK_MANAGER_PLAYING,
	NOISE_PLAYBACK_MANAGER_VOLUME,
	NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA,
	NOISE_PLAYBACK_MANAGER_CURRENT_INDEX
};
NoisePlaybackManager* noise_playback_manager_new (void);
NoisePlaybackManager* noise_playback_manager_construct (GType object_type);
NoiseStreamer* noise_streamer_new (void);
NoiseStreamer* noise_streamer_construct (GType object_type);
static void noise_playback_manager_real_add_playback (NoisePlayer* base, NoisePlayback* playback);
void noise_playback_manager_queue_media (NoisePlaybackManager* self, GeeCollection* to_queue);
void noise_playback_manager_queue_media_by_id (NoisePlaybackManager* self, GeeCollection* ids);
NoiseLibrary* noise_playback_manager_get_library (NoisePlaybackManager* self);
void noise_playback_manager_unqueue_media (NoisePlaybackManager* self, GeeCollection* to_unqueue);
void noise_playback_manager_unqueue_media_by_id (NoisePlaybackManager* self, GeeCollection* ids);
NoiseMedia* noise_playback_manager_peek_queue (NoisePlaybackManager* self);
NoiseMedia* noise_playback_manager_poll_queue (NoisePlaybackManager* self);
gboolean noise_playback_manager_playing_queued_song (NoisePlaybackManager* self);
gboolean noise_playback_manager_is_shuffled (NoisePlaybackManager* self);
NoiseMedia* noise_playback_manager_mediaFromCurrentIndex (NoisePlaybackManager* self, gint index_in_current);
GeeCollection* noise_playback_manager_get_current_media_list (NoisePlaybackManager* self);
void noise_playback_manager_clearCurrent (NoisePlaybackManager* self);
void noise_playback_manager_set_current_index (NoisePlaybackManager* self, gint value);
void noise_playback_manager_reshuffle (NoisePlaybackManager* self);
void noise_playback_manager_addToCurrent (NoisePlaybackManager* self, NoiseMedia* m);
void noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self, NoiseSettingsRepeat mode);
void noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self, NoiseSettingsShuffle mode);
NoiseMedia* noise_playback_manager_get_current_media (NoisePlaybackManager* self);
NoiseMedia* noise_playback_manager_getNext (NoisePlaybackManager* self, gboolean play);
static void noise_playback_manager_set_current_media (NoisePlaybackManager* self, NoiseMedia* value);
void noise_playback_manager_stop_playback (NoisePlaybackManager* self);
void noise_playback_manager_playMedia (NoisePlaybackManager* self, NoiseMedia* m, gboolean use_resume_pos);
NoiseMedia* noise_playback_manager_getPrevious (NoisePlaybackManager* self, gboolean play);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
void noise_playback_manager_set_volume (NoisePlaybackManager* self, gdouble value);
void noise_playback_manager_change_gains_thread (NoisePlaybackManager* self);
gboolean noise_playback_manager_get_playing (NoisePlaybackManager* self);
static gboolean __lambda27_ (Block8Data* _data8_);
static gboolean ___lambda27__gsource_func (gpointer self);
static void noise_playback_manager_set_playing (NoisePlaybackManager* self, gboolean value);
void noise_playback_manager_start_playback (NoisePlaybackManager* self);
void noise_playback_manager_pause_playback (NoisePlaybackManager* self);
gdouble noise_playback_manager_get_volume (NoisePlaybackManager* self);
gint noise_playback_manager_get_current_index (NoisePlaybackManager* self);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static GObject * noise_playback_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
NoiseHistoryPlaylist* noise_history_playlist_new (void);
NoiseHistoryPlaylist* noise_history_playlist_construct (GType object_type);
static void noise_playback_manager_finalize (GObject * obj);
static void _vala_noise_playback_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_noise_playback_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
#line 88 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 195 "PlaybackManager.c"
}


NoisePlaybackManager* noise_playback_manager_construct (GType object_type) {
	NoisePlaybackManager * self = NULL;
	NoiseStreamer* _tmp0_;
	GeeTreeSet* _tmp1_;
	NoiseStreamer* _tmp2_;
	NoiseStreamer* _tmp3_;
	NoisePlayback* _tmp4_;
#line 85 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self = (NoisePlaybackManager*) g_object_new (object_type, NULL);
#line 86 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_streamer_new ();
#line 86 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->file_player);
#line 86 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->file_player = _tmp0_;
#line 87 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = self->priv->playbacks;
#line 87 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = self->file_player;
#line 87 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (NoisePlayback*) _tmp2_);
#line 88 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = self->file_player;
#line 88 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = _g_object_ref0 ((NoisePlayback*) _tmp3_);
#line 88 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->player);
#line 88 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->player = _tmp4_;
#line 85 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return self;
#line 230 "PlaybackManager.c"
}


NoisePlaybackManager* noise_playback_manager_new (void) {
#line 85 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return noise_playback_manager_construct (NOISE_TYPE_PLAYBACK_MANAGER);
#line 237 "PlaybackManager.c"
}


static void noise_playback_manager_real_add_playback (NoisePlayer* base, NoisePlayback* playback) {
	NoisePlaybackManager * self;
	GeeTreeSet* _tmp0_;
	NoisePlayback* _tmp1_;
#line 101 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self = (NoisePlaybackManager*) base;
#line 101 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (playback != NULL);
#line 102 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->priv->playbacks;
#line 102 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = playback;
#line 102 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, _tmp1_);
#line 255 "PlaybackManager.c"
}


void noise_playback_manager_queue_media (NoisePlaybackManager* self, GeeCollection* to_queue) {
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	NoiseStaticPlaylist* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
#line 109 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 109 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (to_queue != NULL);
#line 110 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = to_queue;
#line 110 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 110 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 110 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp2_ < 1) {
#line 111 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		return;
#line 280 "PlaybackManager.c"
	}
#line 113 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = self->queue_playlist;
#line 113 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = to_queue;
#line 113 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playlist_add_medias ((NoisePlaylist*) _tmp3_, _tmp4_);
#line 115 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp5_ = to_queue;
#line 115 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_QUEUED_SIGNAL], 0, _tmp5_);
#line 292 "PlaybackManager.c"
}


void noise_playback_manager_queue_media_by_id (NoisePlaybackManager* self, GeeCollection* ids) {
	NoiseLibrary* _tmp0_;
	NoiseLibrary* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
#line 118 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (ids != NULL);
#line 119 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_playback_manager_get_library (self);
#line 119 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 119 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = ids;
#line 119 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = noise_library_medias_from_ids (_tmp1_, _tmp2_);
#line 119 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 119 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_queue_media (self, _tmp4_);
#line 119 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (_tmp4_);
#line 320 "PlaybackManager.c"
}


void noise_playback_manager_unqueue_media (NoisePlaybackManager* self, GeeCollection* to_unqueue) {
	NoiseStaticPlaylist* _tmp0_;
	GeeCollection* _tmp1_;
#line 123 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 123 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (to_unqueue != NULL);
#line 124 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 124 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = to_unqueue;
#line 124 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playlist_remove_medias ((NoisePlaylist*) _tmp0_, _tmp1_);
#line 337 "PlaybackManager.c"
}


void noise_playback_manager_unqueue_media_by_id (NoisePlaybackManager* self, GeeCollection* ids) {
	NoiseLibrary* _tmp0_;
	NoiseLibrary* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
#line 127 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 127 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (ids != NULL);
#line 128 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_playback_manager_get_library (self);
#line 128 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 128 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = ids;
#line 128 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = noise_library_medias_from_ids (_tmp1_, _tmp2_);
#line 128 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 128 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_unqueue_media (self, _tmp4_);
#line 128 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (_tmp4_);
#line 365 "PlaybackManager.c"
}


NoiseMedia* noise_playback_manager_peek_queue (NoisePlaybackManager* self) {
	NoiseMedia* result = NULL;
	NoiseStaticPlaylist* _tmp0_;
	GeeArrayQueue* _tmp1_;
	GeeArrayQueue* _tmp2_;
	gpointer _tmp3_;
#line 131 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 132 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp0_);
#line 132 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 132 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = gee_deque_peek_head ((GeeDeque*) _tmp2_);
#line 132 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	result = (NoiseMedia*) _tmp3_;
#line 132 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 389 "PlaybackManager.c"
}


NoiseMedia* noise_playback_manager_poll_queue (NoisePlaybackManager* self) {
	NoiseMedia* result = NULL;
	NoiseMedia* m = NULL;
	NoiseStaticPlaylist* _tmp0_;
	GeeArrayQueue* _tmp1_;
	GeeArrayQueue* _tmp2_;
	gpointer _tmp3_;
	GeeLinkedList* unqueued = NULL;
	GeeLinkedList* _tmp4_;
	NoiseStaticPlaylist* _tmp5_;
#line 135 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 136 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 136 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp0_);
#line 136 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 136 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = gee_deque_poll_head ((GeeDeque*) _tmp2_);
#line 136 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	m = (NoiseMedia*) _tmp3_;
#line 137 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 137 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	unqueued = _tmp4_;
#line 138 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) unqueued, m);
#line 139 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp5_ = self->queue_playlist;
#line 139 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_signal_emit_by_name ((NoisePlaylist*) _tmp5_, "media-removed", (GeeCollection*) unqueued);
#line 140 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	result = m;
#line 140 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (unqueued);
#line 140 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 431 "PlaybackManager.c"
}


gboolean noise_playback_manager_playing_queued_song (NoisePlaybackManager* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 146 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 147 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->priv->_playing_queued_song;
#line 147 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	result = _tmp0_;
#line 147 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 446 "PlaybackManager.c"
}


gboolean noise_playback_manager_is_shuffled (NoisePlaybackManager* self) {
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 150 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 151 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 151 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 151 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 151 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	result = _tmp2_ > 0;
#line 151 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 467 "PlaybackManager.c"
}


NoiseMedia* noise_playback_manager_mediaFromCurrentIndex (NoisePlaybackManager* self, gint index_in_current) {
	NoiseMedia* result = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	gboolean _tmp4_;
#line 173 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 174 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 174 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 174 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 174 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 174 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = _tmp3_ == NOISE_SETTINGS_SHUFFLE_OFF;
#line 174 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (_tmp1_);
#line 174 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp4_) {
#line 494 "PlaybackManager.c"
		GeeHashMap* _tmp5_;
		gint _tmp6_;
		gpointer _tmp7_;
#line 175 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current;
#line 175 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp6_ = index_in_current;
#line 175 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) _tmp6_));
#line 175 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		result = (NoiseMedia*) _tmp7_;
#line 175 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		return result;
#line 508 "PlaybackManager.c"
	} else {
		GeeHashMap* _tmp8_;
		gint _tmp9_;
		gpointer _tmp10_;
#line 177 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp8_ = self->priv->_current_shuffled;
#line 177 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp9_ = index_in_current;
#line 177 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp8_, (gpointer) ((gintptr) _tmp9_));
#line 177 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		result = (NoiseMedia*) _tmp10_;
#line 177 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		return result;
#line 523 "PlaybackManager.c"
	}
}


GeeCollection* noise_playback_manager_get_current_media_list (NoisePlaybackManager* self) {
	GeeCollection* result = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	gboolean _tmp4_;
#line 180 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 181 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 181 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 181 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 181 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 181 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = _tmp3_ == NOISE_SETTINGS_SHUFFLE_OFF;
#line 181 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (_tmp1_);
#line 181 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp4_) {
#line 551 "PlaybackManager.c"
		GeeHashMap* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
#line 182 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current_shuffled;
#line 182 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp6_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp5_);
#line 182 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp7_ = _tmp6_;
#line 182 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		result = _tmp7_;
#line 182 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		return result;
#line 565 "PlaybackManager.c"
	} else {
		GeeHashMap* _tmp8_;
		GeeCollection* _tmp9_;
		GeeCollection* _tmp10_;
#line 184 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp8_ = self->priv->_current;
#line 184 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp9_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp8_);
#line 184 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp10_ = _tmp9_;
#line 184 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		result = _tmp10_;
#line 184 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		return result;
#line 580 "PlaybackManager.c"
	}
}


void noise_playback_manager_clearCurrent (NoisePlaybackManager* self) {
	GeeHashMap* _tmp0_;
#line 188 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 189 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CURRENT_CLEARED_SIGNAL], 0);
#line 190 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current;
#line 190 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 191 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_set_current_index (self, 0);
#line 193 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_reshuffle (self);
#line 599 "PlaybackManager.c"
}


void noise_playback_manager_addToCurrent (NoisePlaybackManager* self, NoiseMedia* m) {
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	NoiseMedia* _tmp4_;
#line 197 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 197 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (m != NULL);
#line 198 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current;
#line 198 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current;
#line 198 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
#line 198 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 198 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = m;
#line 198 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) _tmp3_), _tmp4_);
#line 625 "PlaybackManager.c"
}


void noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self, NoiseSettingsRepeat mode) {
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsRepeat _tmp2_;
	NoiseSettingsRepeat _tmp3_;
	NoiseSettingsRepeat _tmp4_;
#line 201 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 202 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 202 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 203 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 203 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_repeat_mode (_tmp1_);
#line 203 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 203 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = mode;
#line 203 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp3_ != _tmp4_) {
#line 652 "PlaybackManager.c"
		NoiseSettingsMain* _tmp5_;
		NoiseSettingsRepeat _tmp6_;
#line 204 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp5_ = main_settings;
#line 204 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp6_ = mode;
#line 204 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_settings_main_set_repeat_mode (_tmp5_, _tmp6_);
#line 661 "PlaybackManager.c"
	}
#line 201 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 665 "PlaybackManager.c"
}


void noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self, NoiseSettingsShuffle mode) {
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseSettingsShuffle _tmp4_;
#line 207 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 208 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 208 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 209 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 209 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 209 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 209 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = mode;
#line 209 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp3_ != _tmp4_) {
#line 692 "PlaybackManager.c"
		NoiseSettingsMain* _tmp5_;
		NoiseSettingsShuffle _tmp6_;
#line 210 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp5_ = main_settings;
#line 210 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp6_ = mode;
#line 210 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_settings_main_set_shuffle_mode (_tmp5_, _tmp6_);
#line 211 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_playback_manager_reshuffle (self);
#line 703 "PlaybackManager.c"
	}
#line 207 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 707 "PlaybackManager.c"
}


void noise_playback_manager_reshuffle (NoisePlaybackManager* self) {
	GeeHashMap* _tmp0_;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsMain* _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseSettingsShuffle _tmp4_;
#line 215 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 216 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 216 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 217 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->priv->_current_shuffled_index = 0;
#line 219 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = noise_settings_main_get_default ();
#line 219 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	main_settings = _tmp1_;
#line 220 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = main_settings;
#line 220 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = noise_settings_main_get_shuffle_mode (_tmp2_);
#line 220 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 220 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp4_ == NOISE_SETTINGS_SHUFFLE_OFF) {
#line 738 "PlaybackManager.c"
		NoiseMedia* _tmp5_;
#line 221 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current_media;
#line 221 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		if (_tmp5_ != NULL) {
#line 744 "PlaybackManager.c"
			{
				gint i = 0;
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				i = 0;
#line 749 "PlaybackManager.c"
				{
					gboolean _tmp6_ = FALSE;
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp6_ = TRUE;
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					while (TRUE) {
#line 756 "PlaybackManager.c"
						gint _tmp8_;
						GeeHashMap* _tmp9_;
						gint _tmp10_;
						gint _tmp11_;
						GeeHashMap* _tmp12_;
						gint _tmp13_;
						gpointer _tmp14_;
						NoiseMedia* _tmp15_;
						NoiseMedia* _tmp16_;
						gboolean _tmp17_;
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (!_tmp6_) {
#line 769 "PlaybackManager.c"
							gint _tmp7_;
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp7_ = i;
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							i = _tmp7_ + 1;
#line 775 "PlaybackManager.c"
						}
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp6_ = FALSE;
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp8_ = i;
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp9_ = self->priv->_current;
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp10_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp9_);
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp11_ = _tmp10_;
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (!(_tmp8_ < _tmp11_)) {
#line 223 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							break;
#line 791 "PlaybackManager.c"
						}
#line 224 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp12_ = self->priv->_current;
#line 224 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp13_ = i;
#line 224 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, (gpointer) ((gintptr) _tmp13_));
#line 224 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp15_ = (NoiseMedia*) _tmp14_;
#line 224 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp16_ = self->priv->_current_media;
#line 224 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp17_ = _tmp15_ == _tmp16_;
#line 224 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (_tmp15_);
#line 224 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp17_) {
#line 809 "PlaybackManager.c"
							gint _tmp18_;
#line 225 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp18_ = i;
#line 225 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							self->priv->_current_index = _tmp18_;
#line 226 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (main_settings);
#line 226 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							return;
#line 819 "PlaybackManager.c"
						}
					}
				}
			}
		} else {
#line 230 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			self->priv->_current_index = 0;
#line 827 "PlaybackManager.c"
		}
	} else {
		NoiseSettingsMain* _tmp19_;
		NoiseSettingsShuffle _tmp20_;
		NoiseSettingsShuffle _tmp21_;
#line 232 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp19_ = main_settings;
#line 232 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp20_ = noise_settings_main_get_shuffle_mode (_tmp19_);
#line 232 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp21_ = _tmp20_;
#line 232 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		if (_tmp21_ == NOISE_SETTINGS_SHUFFLE_ALL) {
#line 841 "PlaybackManager.c"
			GeeLinkedList* temp = NULL;
			GeeLinkedList* _tmp22_;
#line 234 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp22_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 234 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			temp = _tmp22_;
#line 848 "PlaybackManager.c"
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp23_;
				GeeCollection* _tmp24_;
				GeeCollection* _tmp25_;
				GeeCollection* _tmp26_;
				GeeIterator* _tmp27_;
				GeeIterator* _tmp28_;
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp23_ = self->priv->_current;
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp24_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp23_);
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp25_ = _tmp24_;
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp26_ = _tmp25_;
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp27_ = gee_iterable_iterator ((GeeIterable*) _tmp26_);
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp28_ = _tmp27_;
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_g_object_unref0 (_tmp26_);
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_m_it = _tmp28_;
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				while (TRUE) {
#line 875 "PlaybackManager.c"
					GeeIterator* _tmp29_;
					gboolean _tmp30_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp31_;
					gpointer _tmp32_;
					GeeLinkedList* _tmp33_;
					NoiseMedia* _tmp34_;
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp29_ = _m_it;
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp30_ = gee_iterator_next (_tmp29_);
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (!_tmp30_) {
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						break;
#line 891 "PlaybackManager.c"
					}
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp31_ = _m_it;
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp32_ = gee_iterator_get (_tmp31_);
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					m = (NoiseMedia*) _tmp32_;
#line 236 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp33_ = temp;
#line 236 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp34_ = m;
#line 236 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp33_, _tmp34_);
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_object_unref0 (m);
#line 907 "PlaybackManager.c"
				}
#line 235 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_g_object_unref0 (_m_it);
#line 911 "PlaybackManager.c"
			}
			{
				gint i = 0;
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				i = 1;
#line 917 "PlaybackManager.c"
				{
					gboolean _tmp35_ = FALSE;
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp35_ = TRUE;
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					while (TRUE) {
#line 924 "PlaybackManager.c"
						gint _tmp37_;
						GeeHashMap* _tmp38_;
						gint _tmp39_;
						gint _tmp40_;
						gint n_media = 0;
						GeeLinkedList* _tmp41_;
						gint _tmp42_;
						gint _tmp43_;
						gint _tmp44_;
						gint _tmp45_ = 0;
						gint _tmp46_;
						gint random = 0;
						gboolean _tmp49_ = FALSE;
						NoiseMedia* _tmp50_;
						GeeLinkedList* _tmp65_;
						GeeLinkedList* _tmp66_;
						gint _tmp67_;
						gpointer _tmp68_;
						NoiseMedia* _tmp69_;
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (!_tmp35_) {
#line 946 "PlaybackManager.c"
							gint _tmp36_;
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp36_ = i;
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							i = _tmp36_ + 1;
#line 952 "PlaybackManager.c"
						}
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp35_ = FALSE;
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp37_ = i;
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp38_ = self->priv->_current;
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp39_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp38_);
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp40_ = _tmp39_;
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (!(_tmp37_ < _tmp40_)) {
#line 242 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							break;
#line 968 "PlaybackManager.c"
						}
#line 243 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp41_ = temp;
#line 243 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 243 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp43_ = _tmp42_;
#line 243 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						n_media = _tmp43_;
#line 244 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp44_ = n_media;
#line 244 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp44_ == 0) {
#line 245 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							break;
#line 984 "PlaybackManager.c"
						}
#line 247 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp46_ = n_media;
#line 247 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp46_ <= 1) {
#line 247 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp45_ = 0;
#line 992 "PlaybackManager.c"
						} else {
							gint _tmp47_;
							gint32 _tmp48_;
#line 247 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp47_ = n_media;
#line 247 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp48_ = g_random_int_range ((gint32) 0, (gint32) (_tmp47_ - 1));
#line 247 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp45_ = (gint) _tmp48_;
#line 1002 "PlaybackManager.c"
						}
#line 247 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						random = _tmp45_;
#line 249 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp50_ = self->priv->_current_media;
#line 249 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp50_ != NULL) {
#line 1010 "PlaybackManager.c"
							GeeLinkedList* _tmp51_;
							gint _tmp52_;
							gpointer _tmp53_;
							NoiseMedia* _tmp54_;
							NoiseMedia* _tmp55_;
#line 249 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp51_ = temp;
#line 249 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp52_ = random;
#line 249 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp53_ = gee_abstract_list_get ((GeeAbstractList*) _tmp51_, _tmp52_);
#line 249 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp54_ = (NoiseMedia*) _tmp53_;
#line 249 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp55_ = self->priv->_current_media;
#line 249 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp49_ = _tmp54_ == _tmp55_;
#line 249 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (_tmp54_);
#line 1030 "PlaybackManager.c"
						} else {
#line 249 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp49_ = FALSE;
#line 1034 "PlaybackManager.c"
						}
#line 249 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp49_) {
#line 1038 "PlaybackManager.c"
							GeeHashMap* _tmp56_;
							NoiseMedia* _tmp57_;
							gint _tmp58_;
#line 250 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp56_ = self->priv->_current_shuffled;
#line 250 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp57_ = self->priv->_current_media;
#line 250 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp56_, (gpointer) ((gintptr) 0), _tmp57_);
#line 251 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp58_ = i;
#line 251 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							i = _tmp58_ - 1;
#line 1052 "PlaybackManager.c"
						} else {
							GeeHashMap* _tmp59_;
							gint _tmp60_;
							GeeLinkedList* _tmp61_;
							gint _tmp62_;
							gpointer _tmp63_;
							NoiseMedia* _tmp64_;
#line 253 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp59_ = self->priv->_current_shuffled;
#line 253 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp60_ = i;
#line 253 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp61_ = temp;
#line 253 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp62_ = random;
#line 253 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp63_ = gee_abstract_list_get ((GeeAbstractList*) _tmp61_, _tmp62_);
#line 253 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp64_ = (NoiseMedia*) _tmp63_;
#line 253 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp59_, (gpointer) ((gintptr) _tmp60_), _tmp64_);
#line 253 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (_tmp64_);
#line 1076 "PlaybackManager.c"
						}
#line 255 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp65_ = temp;
#line 255 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp66_ = temp;
#line 255 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp67_ = random;
#line 255 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp68_ = gee_abstract_list_get ((GeeAbstractList*) _tmp66_, _tmp67_);
#line 255 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp69_ = (NoiseMedia*) _tmp68_;
#line 255 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp65_, _tmp69_);
#line 255 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (_tmp69_);
#line 1092 "PlaybackManager.c"
					}
				}
			}
#line 232 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_g_object_unref0 (temp);
#line 1098 "PlaybackManager.c"
		}
	}
#line 215 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 1103 "PlaybackManager.c"
}


NoiseMedia* noise_playback_manager_getNext (NoisePlaybackManager* self, gboolean play) {
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	GeeArrayQueue* _tmp2_;
	GeeArrayQueue* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp195_;
#line 260 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 261 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	rv = NULL;
#line 263 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 263 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 265 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = self->queue_playlist;
#line 265 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp1_);
#line 265 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 265 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 265 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp5_ = _tmp4_;
#line 265 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp5_ > 0) {
#line 1138 "PlaybackManager.c"
		NoiseMedia* _tmp6_;
#line 266 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp6_ = noise_playback_manager_poll_queue (self);
#line 266 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (rv);
#line 266 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		rv = _tmp6_;
#line 267 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		self->priv->_playing_queued_song = TRUE;
#line 1148 "PlaybackManager.c"
	} else {
		NoiseSettingsMain* _tmp7_;
		NoiseSettingsShuffle _tmp8_;
		NoiseSettingsShuffle _tmp9_;
#line 268 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp7_ = main_settings;
#line 268 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp8_ = noise_settings_main_get_shuffle_mode (_tmp7_);
#line 268 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 268 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		if (_tmp9_ != NOISE_SETTINGS_SHUFFLE_OFF) {
#line 1161 "PlaybackManager.c"
			GeeHashMap* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
			NoiseMedia* _tmp24_;
#line 269 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp10_ = self->priv->_current_shuffled;
#line 269 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp11_ = gee_map_get_is_empty ((GeeMap*) _tmp10_);
#line 269 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp12_ = _tmp11_;
#line 269 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			if (_tmp12_) {
#line 1174 "PlaybackManager.c"
				{
					GeeIterator* _s_it = NULL;
					NoiseLibrary* _tmp13_;
					NoiseLibrary* _tmp14_;
					GeeCollection* _tmp15_;
					GeeCollection* _tmp16_;
					GeeIterator* _tmp17_;
					GeeIterator* _tmp18_;
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp13_ = noise_playback_manager_get_library (self);
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp14_ = _tmp13_;
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp15_ = noise_library_get_medias (_tmp14_);
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp16_ = _tmp15_;
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp18_ = _tmp17_;
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_object_unref0 (_tmp16_);
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_s_it = _tmp18_;
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					while (TRUE) {
#line 1201 "PlaybackManager.c"
						GeeIterator* _tmp19_;
						gboolean _tmp20_;
						NoiseMedia* s = NULL;
						GeeIterator* _tmp21_;
						gpointer _tmp22_;
						NoiseMedia* _tmp23_;
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp19_ = _s_it;
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp20_ = gee_iterator_next (_tmp19_);
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (!_tmp20_) {
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							break;
#line 1216 "PlaybackManager.c"
						}
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp21_ = _s_it;
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp22_ = gee_iterator_get (_tmp21_);
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						s = (NoiseMedia*) _tmp22_;
#line 271 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp23_ = s;
#line 271 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						noise_playback_manager_addToCurrent (self, _tmp23_);
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (s);
#line 1230 "PlaybackManager.c"
					}
#line 270 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_object_unref0 (_s_it);
#line 1234 "PlaybackManager.c"
				}
#line 272 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				noise_playback_manager_reshuffle (self);
#line 1238 "PlaybackManager.c"
			}
#line 274 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			self->priv->_playing_queued_song = FALSE;
#line 276 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp24_ = self->priv->_current_media;
#line 276 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			if (_tmp24_ == NULL) {
#line 1246 "PlaybackManager.c"
				GeeHashMap* _tmp25_;
				gpointer _tmp26_;
#line 277 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				self->priv->_current_shuffled_index = 0;
#line 278 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp25_ = self->priv->_current_shuffled;
#line 278 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp26_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp25_, (gpointer) ((gintptr) 0));
#line 278 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 278 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp26_;
#line 1259 "PlaybackManager.c"
			} else {
				NoiseSettingsMain* _tmp27_;
				NoiseSettingsRepeat _tmp28_;
				NoiseSettingsRepeat _tmp29_;
#line 279 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp27_ = main_settings;
#line 279 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp28_ = noise_settings_main_get_repeat_mode (_tmp27_);
#line 279 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp29_ = _tmp28_;
#line 279 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (_tmp29_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 1272 "PlaybackManager.c"
					GeeHashMap* _tmp30_;
					gint _tmp31_;
					gpointer _tmp32_;
#line 280 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp30_ = self->priv->_current_shuffled;
#line 280 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp31_ = self->priv->_current_shuffled_index;
#line 280 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp32_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp30_, (gpointer) ((gintptr) _tmp31_));
#line 280 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 280 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp32_;
#line 1286 "PlaybackManager.c"
				} else {
					gint _tmp33_;
					GeeHashMap* _tmp34_;
					gint _tmp35_;
					gint _tmp36_;
#line 281 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp33_ = self->priv->_current_shuffled_index;
#line 281 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp34_ = self->priv->_current_shuffled;
#line 281 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp35_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp34_);
#line 281 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp36_ = _tmp35_;
#line 281 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp33_ == (_tmp36_ - 1)) {
#line 1302 "PlaybackManager.c"
						NoiseSettingsMain* _tmp37_;
						NoiseSettingsRepeat _tmp38_;
						NoiseSettingsRepeat _tmp39_;
						GeeHashMap* _tmp43_;
						gpointer _tmp44_;
#line 282 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp37_ = main_settings;
#line 282 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp38_ = noise_settings_main_get_repeat_mode (_tmp37_);
#line 282 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp39_ = _tmp38_;
#line 282 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp39_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 283 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							self->priv->_current_shuffled_index = 0;
#line 1318 "PlaybackManager.c"
						} else {
							GeeHashMap* _tmp40_;
							GeeHashMap* _tmp41_;
							gboolean _tmp42_;
#line 286 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							noise_playback_manager_set_current_media (self, NULL);
#line 287 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp40_ = self->priv->_current_shuffled;
#line 287 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							gee_abstract_map_clear ((GeeAbstractMap*) _tmp40_);
#line 288 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp41_ = self->priv->_current;
#line 288 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							gee_abstract_map_clear ((GeeAbstractMap*) _tmp41_);
#line 289 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							self->priv->_current_shuffled_index = 0;
#line 290 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							self->priv->_current_index = 0;
#line 292 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp42_ = play;
#line 292 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (_tmp42_) {
#line 293 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								noise_playback_manager_stop_playback (self);
#line 1343 "PlaybackManager.c"
							}
#line 296 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							result = NULL;
#line 296 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (main_settings);
#line 296 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 296 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							return result;
#line 1353 "PlaybackManager.c"
						}
#line 299 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp43_ = self->priv->_current_shuffled;
#line 299 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp44_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp43_, (gpointer) ((gintptr) 0));
#line 299 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 299 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp44_;
#line 1363 "PlaybackManager.c"
					} else {
						gboolean _tmp45_ = FALSE;
						gint _tmp46_;
#line 300 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp46_ = self->priv->_current_shuffled_index;
#line 300 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp46_ >= 0) {
#line 1371 "PlaybackManager.c"
							gint _tmp47_;
							GeeHashMap* _tmp48_;
							gint _tmp49_;
							gint _tmp50_;
#line 300 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp47_ = self->priv->_current_shuffled_index;
#line 300 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp48_ = self->priv->_current_shuffled;
#line 300 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp49_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp48_);
#line 300 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp50_ = _tmp49_;
#line 300 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp45_ = _tmp47_ < (_tmp50_ - 1);
#line 1386 "PlaybackManager.c"
						} else {
#line 300 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp45_ = FALSE;
#line 1390 "PlaybackManager.c"
						}
#line 300 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp45_) {
#line 1394 "PlaybackManager.c"
							NoiseMedia* next_current = NULL;
							GeeHashMap* _tmp51_;
							gint _tmp52_;
							gpointer _tmp53_;
							NoiseMedia* now_current = NULL;
							GeeHashMap* _tmp54_;
							gint _tmp55_;
							gpointer _tmp56_;
							gboolean _tmp57_ = FALSE;
							NoiseSettingsMain* _tmp58_;
							NoiseSettingsRepeat _tmp59_;
							NoiseSettingsRepeat _tmp60_;
							GeeHashMap* _tmp100_;
							gint _tmp101_;
							gpointer _tmp102_;
#line 302 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp51_ = self->priv->_current_shuffled;
#line 302 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp52_ = self->priv->_current_shuffled_index;
#line 302 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp53_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp51_, (gpointer) ((gintptr) (_tmp52_ + 1)));
#line 302 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							next_current = (NoiseMedia*) _tmp53_;
#line 303 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp54_ = self->priv->_current_shuffled;
#line 303 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp55_ = self->priv->_current_shuffled_index;
#line 303 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp56_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp54_, (gpointer) ((gintptr) _tmp55_));
#line 303 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							now_current = (NoiseMedia*) _tmp56_;
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp58_ = main_settings;
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp59_ = noise_settings_main_get_repeat_mode (_tmp58_);
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp60_ = _tmp59_;
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (_tmp60_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 1434 "PlaybackManager.c"
								NoiseMedia* _tmp61_;
								const gchar* _tmp62_;
								const gchar* _tmp63_;
								NoiseMedia* _tmp64_;
								const gchar* _tmp65_;
								const gchar* _tmp66_;
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp61_ = next_current;
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp62_ = noise_media_get_artist (_tmp61_);
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp63_ = _tmp62_;
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp64_ = now_current;
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp65_ = noise_media_get_artist (_tmp64_);
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp66_ = _tmp65_;
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp57_ = g_strcmp0 (_tmp63_, _tmp66_) != 0;
#line 1455 "PlaybackManager.c"
							} else {
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp57_ = FALSE;
#line 1459 "PlaybackManager.c"
							}
#line 305 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (_tmp57_) {
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								while (TRUE) {
#line 1465 "PlaybackManager.c"
									GeeHashMap* _tmp67_;
									gint _tmp68_;
									gpointer _tmp69_;
									NoiseMedia* _tmp70_;
									const gchar* _tmp71_;
									const gchar* _tmp72_;
									NoiseMedia* _tmp73_;
									const gchar* _tmp74_;
									const gchar* _tmp75_;
									gboolean _tmp76_;
									gint _tmp77_;
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp67_ = self->priv->_current_shuffled;
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp68_ = self->priv->_current_shuffled_index;
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp69_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp67_, (gpointer) ((gintptr) (_tmp68_ - 1)));
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp70_ = (NoiseMedia*) _tmp69_;
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp71_ = noise_media_get_artist (_tmp70_);
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp72_ = _tmp71_;
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp73_ = self->priv->_current_media;
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp74_ = noise_media_get_artist (_tmp73_);
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp75_ = _tmp74_;
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp76_ = !(g_strcmp0 (_tmp72_, _tmp75_) == 0);
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_g_object_unref0 (_tmp70_);
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									if (_tmp76_) {
#line 306 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										break;
#line 1503 "PlaybackManager.c"
									}
#line 307 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp77_ = self->priv->_current_shuffled_index;
#line 307 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = _tmp77_ - 1;
#line 1509 "PlaybackManager.c"
								}
							} else {
								gboolean _tmp78_ = FALSE;
								NoiseSettingsMain* _tmp79_;
								NoiseSettingsRepeat _tmp80_;
								NoiseSettingsRepeat _tmp81_;
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp79_ = main_settings;
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp80_ = noise_settings_main_get_repeat_mode (_tmp79_);
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp81_ = _tmp80_;
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								if (_tmp81_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 1524 "PlaybackManager.c"
									NoiseMedia* _tmp82_;
									const gchar* _tmp83_;
									const gchar* _tmp84_;
									NoiseMedia* _tmp85_;
									const gchar* _tmp86_;
									const gchar* _tmp87_;
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp82_ = next_current;
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp83_ = noise_media_get_album (_tmp82_);
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp84_ = _tmp83_;
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp85_ = now_current;
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp86_ = noise_media_get_album (_tmp85_);
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp87_ = _tmp86_;
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp78_ = g_strcmp0 (_tmp84_, _tmp87_) != 0;
#line 1545 "PlaybackManager.c"
								} else {
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp78_ = FALSE;
#line 1549 "PlaybackManager.c"
								}
#line 309 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								if (_tmp78_) {
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									while (TRUE) {
#line 1555 "PlaybackManager.c"
										GeeHashMap* _tmp88_;
										gint _tmp89_;
										gpointer _tmp90_;
										NoiseMedia* _tmp91_;
										const gchar* _tmp92_;
										const gchar* _tmp93_;
										NoiseMedia* _tmp94_;
										const gchar* _tmp95_;
										const gchar* _tmp96_;
										gboolean _tmp97_;
										gint _tmp98_;
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp88_ = self->priv->_current_shuffled;
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp89_ = self->priv->_current_shuffled_index;
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp90_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp88_, (gpointer) ((gintptr) (_tmp89_ - 1)));
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp91_ = (NoiseMedia*) _tmp90_;
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp92_ = noise_media_get_album (_tmp91_);
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp93_ = _tmp92_;
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp94_ = self->priv->_current_media;
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp95_ = noise_media_get_album (_tmp94_);
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp96_ = _tmp95_;
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp97_ = !(g_strcmp0 (_tmp93_, _tmp96_) == 0);
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_g_object_unref0 (_tmp91_);
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										if (_tmp97_) {
#line 310 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
											break;
#line 1593 "PlaybackManager.c"
										}
#line 311 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp98_ = self->priv->_current_shuffled_index;
#line 311 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										self->priv->_current_shuffled_index = _tmp98_ - 1;
#line 1599 "PlaybackManager.c"
									}
								} else {
									gint _tmp99_;
#line 314 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp99_ = self->priv->_current_shuffled_index;
#line 314 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = _tmp99_ + 1;
#line 1607 "PlaybackManager.c"
								}
							}
#line 317 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp100_ = self->priv->_current_shuffled;
#line 317 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp101_ = self->priv->_current_shuffled_index;
#line 317 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp102_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp100_, (gpointer) ((gintptr) _tmp101_));
#line 317 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 317 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							rv = (NoiseMedia*) _tmp102_;
#line 300 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (now_current);
#line 300 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (next_current);
#line 1624 "PlaybackManager.c"
						} else {
							GeeHashMap* _tmp103_;
							gpointer _tmp104_;
#line 319 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							self->priv->_current_shuffled_index = 0;
#line 320 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							noise_playback_manager_set_shuffle_mode (self, NOISE_SETTINGS_SHUFFLE_ALL);
#line 321 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp103_ = self->priv->_current_shuffled;
#line 321 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp104_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp103_, (gpointer) ((gintptr) 0));
#line 321 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 321 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							rv = (NoiseMedia*) _tmp104_;
#line 1640 "PlaybackManager.c"
						}
					}
				}
			}
		} else {
			NoiseMedia* _tmp105_;
#line 324 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			self->priv->_playing_queued_song = FALSE;
#line 326 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp105_ = self->priv->_current_media;
#line 326 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			if (_tmp105_ == NULL) {
#line 1653 "PlaybackManager.c"
				GeeHashMap* _tmp106_;
				gpointer _tmp107_;
#line 327 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				self->priv->_current_index = 0;
#line 328 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp106_ = self->priv->_current;
#line 328 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp107_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp106_, (gpointer) ((gintptr) 0));
#line 328 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 328 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp107_;
#line 1666 "PlaybackManager.c"
			} else {
				NoiseSettingsMain* _tmp108_;
				NoiseSettingsRepeat _tmp109_;
				NoiseSettingsRepeat _tmp110_;
#line 329 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp108_ = main_settings;
#line 329 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp109_ = noise_settings_main_get_repeat_mode (_tmp108_);
#line 329 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp110_ = _tmp109_;
#line 329 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (_tmp110_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 1679 "PlaybackManager.c"
					GeeHashMap* _tmp111_;
					gint _tmp112_;
					gpointer _tmp113_;
#line 330 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp111_ = self->priv->_current;
#line 330 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp112_ = self->priv->_current_index;
#line 330 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp113_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp111_, (gpointer) ((gintptr) _tmp112_));
#line 330 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 330 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp113_;
#line 1693 "PlaybackManager.c"
				} else {
					gint _tmp114_;
					GeeHashMap* _tmp115_;
					gint _tmp116_;
					gint _tmp117_;
#line 331 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp114_ = self->priv->_current_index;
#line 331 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp115_ = self->priv->_current;
#line 331 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp116_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp115_);
#line 331 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp117_ = _tmp116_;
#line 331 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp114_ == (_tmp117_ - 1)) {
#line 1709 "PlaybackManager.c"
						NoiseSettingsMain* _tmp118_;
						NoiseSettingsRepeat _tmp119_;
						NoiseSettingsRepeat _tmp120_;
						GeeHashMap* _tmp122_;
						gpointer _tmp123_;
#line 332 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp118_ = main_settings;
#line 332 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp119_ = noise_settings_main_get_repeat_mode (_tmp118_);
#line 332 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp120_ = _tmp119_;
#line 332 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp120_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 333 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							self->priv->_current_index = 0;
#line 1725 "PlaybackManager.c"
						} else {
							gboolean _tmp121_;
#line 335 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp121_ = play;
#line 335 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (_tmp121_) {
#line 336 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								noise_playback_manager_stop_playback (self);
#line 1734 "PlaybackManager.c"
							}
#line 338 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							result = NULL;
#line 338 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (main_settings);
#line 338 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 338 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							return result;
#line 1744 "PlaybackManager.c"
						}
#line 341 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp122_ = self->priv->_current;
#line 341 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp123_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp122_, (gpointer) ((gintptr) 0));
#line 341 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 341 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp123_;
#line 1754 "PlaybackManager.c"
					} else {
						gboolean _tmp124_ = FALSE;
						gint _tmp125_;
#line 342 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp125_ = self->priv->_current_index;
#line 342 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp125_ >= 0) {
#line 1762 "PlaybackManager.c"
							gint _tmp126_;
							GeeHashMap* _tmp127_;
							gint _tmp128_;
							gint _tmp129_;
#line 342 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp126_ = self->priv->_current_index;
#line 342 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp127_ = self->priv->_current;
#line 342 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp128_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp127_);
#line 342 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp129_ = _tmp128_;
#line 342 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp124_ = _tmp126_ < (_tmp129_ - 1);
#line 1777 "PlaybackManager.c"
						} else {
#line 342 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp124_ = FALSE;
#line 1781 "PlaybackManager.c"
						}
#line 342 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp124_) {
#line 1785 "PlaybackManager.c"
							NoiseMedia* next_current = NULL;
							GeeHashMap* _tmp130_;
							gint _tmp131_;
							gpointer _tmp132_;
							NoiseMedia* now_current = NULL;
							GeeHashMap* _tmp133_;
							gint _tmp134_;
							gpointer _tmp135_;
							gboolean _tmp136_ = FALSE;
							NoiseSettingsMain* _tmp137_;
							NoiseSettingsRepeat _tmp138_;
							NoiseSettingsRepeat _tmp139_;
							GeeHashMap* _tmp179_;
							gint _tmp180_;
							gpointer _tmp181_;
#line 344 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp130_ = self->priv->_current;
#line 344 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp131_ = self->priv->_current_index;
#line 344 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp132_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp130_, (gpointer) ((gintptr) (_tmp131_ + 1)));
#line 344 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							next_current = (NoiseMedia*) _tmp132_;
#line 345 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp133_ = self->priv->_current;
#line 345 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp134_ = self->priv->_current_index;
#line 345 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp135_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp133_, (gpointer) ((gintptr) _tmp134_));
#line 345 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							now_current = (NoiseMedia*) _tmp135_;
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp137_ = main_settings;
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp138_ = noise_settings_main_get_repeat_mode (_tmp137_);
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp139_ = _tmp138_;
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (_tmp139_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 1825 "PlaybackManager.c"
								NoiseMedia* _tmp140_;
								const gchar* _tmp141_;
								const gchar* _tmp142_;
								NoiseMedia* _tmp143_;
								const gchar* _tmp144_;
								const gchar* _tmp145_;
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp140_ = next_current;
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp141_ = noise_media_get_artist (_tmp140_);
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp142_ = _tmp141_;
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp143_ = now_current;
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp144_ = noise_media_get_artist (_tmp143_);
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp145_ = _tmp144_;
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp136_ = g_strcmp0 (_tmp142_, _tmp145_) != 0;
#line 1846 "PlaybackManager.c"
							} else {
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp136_ = FALSE;
#line 1850 "PlaybackManager.c"
							}
#line 347 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (_tmp136_) {
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								while (TRUE) {
#line 1856 "PlaybackManager.c"
									GeeHashMap* _tmp146_;
									gint _tmp147_;
									gpointer _tmp148_;
									NoiseMedia* _tmp149_;
									const gchar* _tmp150_;
									const gchar* _tmp151_;
									NoiseMedia* _tmp152_;
									const gchar* _tmp153_;
									const gchar* _tmp154_;
									gboolean _tmp155_;
									gint _tmp156_;
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp146_ = self->priv->_current;
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp147_ = self->priv->_current_index;
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp148_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp146_, (gpointer) ((gintptr) (_tmp147_ - 1)));
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp149_ = (NoiseMedia*) _tmp148_;
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp150_ = noise_media_get_artist (_tmp149_);
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp151_ = _tmp150_;
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp152_ = self->priv->_current_media;
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp153_ = noise_media_get_artist (_tmp152_);
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp154_ = _tmp153_;
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp155_ = !(g_strcmp0 (_tmp151_, _tmp154_) == 0);
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_g_object_unref0 (_tmp149_);
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									if (_tmp155_) {
#line 348 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										break;
#line 1894 "PlaybackManager.c"
									}
#line 349 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp156_ = self->priv->_current_index;
#line 349 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									self->priv->_current_index = _tmp156_ - 1;
#line 1900 "PlaybackManager.c"
								}
							} else {
								gboolean _tmp157_ = FALSE;
								NoiseSettingsMain* _tmp158_;
								NoiseSettingsRepeat _tmp159_;
								NoiseSettingsRepeat _tmp160_;
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp158_ = main_settings;
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp159_ = noise_settings_main_get_repeat_mode (_tmp158_);
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp160_ = _tmp159_;
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								if (_tmp160_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 1915 "PlaybackManager.c"
									NoiseMedia* _tmp161_;
									const gchar* _tmp162_;
									const gchar* _tmp163_;
									NoiseMedia* _tmp164_;
									const gchar* _tmp165_;
									const gchar* _tmp166_;
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp161_ = next_current;
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp162_ = noise_media_get_album (_tmp161_);
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp163_ = _tmp162_;
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp164_ = now_current;
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp165_ = noise_media_get_album (_tmp164_);
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp166_ = _tmp165_;
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp157_ = g_strcmp0 (_tmp163_, _tmp166_) != 0;
#line 1936 "PlaybackManager.c"
								} else {
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp157_ = FALSE;
#line 1940 "PlaybackManager.c"
								}
#line 351 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								if (_tmp157_) {
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									while (TRUE) {
#line 1946 "PlaybackManager.c"
										GeeHashMap* _tmp167_;
										gint _tmp168_;
										gpointer _tmp169_;
										NoiseMedia* _tmp170_;
										const gchar* _tmp171_;
										const gchar* _tmp172_;
										NoiseMedia* _tmp173_;
										const gchar* _tmp174_;
										const gchar* _tmp175_;
										gboolean _tmp176_;
										gint _tmp177_;
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp167_ = self->priv->_current;
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp168_ = self->priv->_current_index;
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp169_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp167_, (gpointer) ((gintptr) (_tmp168_ - 1)));
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp170_ = (NoiseMedia*) _tmp169_;
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp171_ = noise_media_get_album (_tmp170_);
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp172_ = _tmp171_;
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp173_ = self->priv->_current_media;
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp174_ = noise_media_get_album (_tmp173_);
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp175_ = _tmp174_;
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp176_ = !(g_strcmp0 (_tmp172_, _tmp175_) == 0);
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_g_object_unref0 (_tmp170_);
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										if (_tmp176_) {
#line 352 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
											break;
#line 1984 "PlaybackManager.c"
										}
#line 353 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp177_ = self->priv->_current_index;
#line 353 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										self->priv->_current_index = _tmp177_ - 1;
#line 1990 "PlaybackManager.c"
									}
								} else {
									gint _tmp178_;
#line 356 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp178_ = self->priv->_current_index;
#line 356 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									self->priv->_current_index = _tmp178_ + 1;
#line 1998 "PlaybackManager.c"
								}
							}
#line 359 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp179_ = self->priv->_current;
#line 359 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp180_ = self->priv->_current_index;
#line 359 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp181_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp179_, (gpointer) ((gintptr) _tmp180_));
#line 359 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 359 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							rv = (NoiseMedia*) _tmp181_;
#line 342 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (now_current);
#line 342 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (next_current);
#line 2015 "PlaybackManager.c"
						} else {
							GeeHashMap* _tmp193_;
							gpointer _tmp194_;
							{
								GeeIterator* _s_it = NULL;
								NoiseLibrary* _tmp182_;
								NoiseLibrary* _tmp183_;
								GeeCollection* _tmp184_;
								GeeCollection* _tmp185_;
								GeeIterator* _tmp186_;
								GeeIterator* _tmp187_;
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp182_ = noise_playback_manager_get_library (self);
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp183_ = _tmp182_;
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp184_ = noise_library_get_medias (_tmp183_);
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp185_ = _tmp184_;
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp186_ = gee_iterable_iterator ((GeeIterable*) _tmp185_);
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp187_ = _tmp186_;
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_g_object_unref0 (_tmp185_);
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_s_it = _tmp187_;
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								while (TRUE) {
#line 2045 "PlaybackManager.c"
									GeeIterator* _tmp188_;
									gboolean _tmp189_;
									NoiseMedia* s = NULL;
									GeeIterator* _tmp190_;
									gpointer _tmp191_;
									NoiseMedia* _tmp192_;
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp188_ = _s_it;
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp189_ = gee_iterator_next (_tmp188_);
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									if (!_tmp189_) {
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										break;
#line 2060 "PlaybackManager.c"
									}
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp190_ = _s_it;
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp191_ = gee_iterator_get (_tmp190_);
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									s = (NoiseMedia*) _tmp191_;
#line 362 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp192_ = s;
#line 362 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									noise_playback_manager_addToCurrent (self, _tmp192_);
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_g_object_unref0 (s);
#line 2074 "PlaybackManager.c"
								}
#line 361 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_g_object_unref0 (_s_it);
#line 2078 "PlaybackManager.c"
							}
#line 365 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							self->priv->_current_index = 0;
#line 366 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp193_ = self->priv->_current;
#line 366 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp194_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp193_, (gpointer) ((gintptr) 0));
#line 366 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 366 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							rv = (NoiseMedia*) _tmp194_;
#line 2090 "PlaybackManager.c"
						}
					}
				}
			}
		}
	}
#line 370 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp195_ = play;
#line 370 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp195_) {
#line 2101 "PlaybackManager.c"
		NoiseMedia* _tmp196_;
#line 371 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp196_ = rv;
#line 371 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_playback_manager_playMedia (self, _tmp196_, FALSE);
#line 2107 "PlaybackManager.c"
	}
#line 374 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	result = rv;
#line 374 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 374 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 2115 "PlaybackManager.c"
}


NoiseMedia* noise_playback_manager_getPrevious (NoisePlaybackManager* self, gboolean play) {
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	gboolean _tmp215_;
#line 378 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 379 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	rv = NULL;
#line 381 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 381 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 382 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 382 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 382 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 382 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp3_ != NOISE_SETTINGS_SHUFFLE_OFF) {
#line 2144 "PlaybackManager.c"
		GeeHashMap* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		NoiseMedia* _tmp18_;
#line 383 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp4_ = self->priv->_current_shuffled;
#line 383 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp5_ = gee_map_get_is_empty ((GeeMap*) _tmp4_);
#line 383 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp6_ = _tmp5_;
#line 383 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		if (_tmp6_) {
#line 2157 "PlaybackManager.c"
			{
				GeeIterator* _s_it = NULL;
				NoiseLibrary* _tmp7_;
				NoiseLibrary* _tmp8_;
				GeeCollection* _tmp9_;
				GeeCollection* _tmp10_;
				GeeIterator* _tmp11_;
				GeeIterator* _tmp12_;
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp7_ = noise_playback_manager_get_library (self);
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp8_ = _tmp7_;
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp9_ = noise_library_get_medias (_tmp8_);
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp10_ = _tmp9_;
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp11_ = gee_iterable_iterator ((GeeIterable*) _tmp10_);
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp12_ = _tmp11_;
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_g_object_unref0 (_tmp10_);
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_s_it = _tmp12_;
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				while (TRUE) {
#line 2184 "PlaybackManager.c"
					GeeIterator* _tmp13_;
					gboolean _tmp14_;
					NoiseMedia* s = NULL;
					GeeIterator* _tmp15_;
					gpointer _tmp16_;
					NoiseMedia* _tmp17_;
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp13_ = _s_it;
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp14_ = gee_iterator_next (_tmp13_);
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (!_tmp14_) {
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						break;
#line 2199 "PlaybackManager.c"
					}
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp15_ = _s_it;
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp16_ = gee_iterator_get (_tmp15_);
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					s = (NoiseMedia*) _tmp16_;
#line 385 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp17_ = s;
#line 385 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					noise_playback_manager_addToCurrent (self, _tmp17_);
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_object_unref0 (s);
#line 2213 "PlaybackManager.c"
				}
#line 384 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_g_object_unref0 (_s_it);
#line 2217 "PlaybackManager.c"
			}
#line 386 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			noise_playback_manager_reshuffle (self);
#line 2221 "PlaybackManager.c"
		}
#line 389 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 391 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp18_ = self->priv->_current_media;
#line 391 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		if (_tmp18_ == NULL) {
#line 2229 "PlaybackManager.c"
			GeeHashMap* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			GeeHashMap* _tmp22_;
			gint _tmp23_;
			gpointer _tmp24_;
#line 392 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp19_ = self->priv->_current_shuffled;
#line 392 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp20_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp19_);
#line 392 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp21_ = _tmp20_;
#line 392 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			self->priv->_current_shuffled_index = _tmp21_ - 1;
#line 393 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp22_ = self->priv->_current_shuffled;
#line 393 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp23_ = self->priv->_current_shuffled_index;
#line 393 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp24_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp22_, (gpointer) ((gintptr) _tmp23_));
#line 393 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 393 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp24_;
#line 2254 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp25_;
			NoiseSettingsRepeat _tmp26_;
			NoiseSettingsRepeat _tmp27_;
#line 394 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp25_ = main_settings;
#line 394 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp26_ = noise_settings_main_get_repeat_mode (_tmp25_);
#line 394 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp27_ = _tmp26_;
#line 394 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			if (_tmp27_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 2267 "PlaybackManager.c"
				GeeHashMap* _tmp28_;
				gint _tmp29_;
				gpointer _tmp30_;
#line 395 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp28_ = self->priv->_current_shuffled;
#line 395 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp29_ = self->priv->_current_shuffled_index;
#line 395 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp30_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp28_, (gpointer) ((gintptr) _tmp29_));
#line 395 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 395 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp30_;
#line 2281 "PlaybackManager.c"
			} else {
				gint _tmp31_;
#line 396 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp31_ = self->priv->_current_shuffled_index;
#line 396 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (_tmp31_ == 0) {
#line 2288 "PlaybackManager.c"
					NoiseSettingsMain* _tmp32_;
					NoiseSettingsRepeat _tmp33_;
					NoiseSettingsRepeat _tmp34_;
					GeeHashMap* _tmp38_;
					gint _tmp39_;
					gpointer _tmp40_;
#line 397 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp32_ = main_settings;
#line 397 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp33_ = noise_settings_main_get_repeat_mode (_tmp32_);
#line 397 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp34_ = _tmp33_;
#line 397 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp34_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 2303 "PlaybackManager.c"
						GeeHashMap* _tmp35_;
						gint _tmp36_;
						gint _tmp37_;
#line 398 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp35_ = self->priv->_current_shuffled;
#line 398 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp36_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp35_);
#line 398 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp37_ = _tmp36_;
#line 398 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = _tmp37_ - 1;
#line 2315 "PlaybackManager.c"
					} else {
#line 400 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						noise_playback_manager_stop_playback (self);
#line 401 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						result = NULL;
#line 401 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 401 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 401 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						return result;
#line 2327 "PlaybackManager.c"
					}
#line 404 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp38_ = self->priv->_current_shuffled;
#line 404 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp39_ = self->priv->_current_shuffled_index;
#line 404 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp40_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp38_, (gpointer) ((gintptr) _tmp39_));
#line 404 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 404 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp40_;
#line 2339 "PlaybackManager.c"
				} else {
					gboolean _tmp41_ = FALSE;
					gint _tmp42_;
#line 405 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp42_ = self->priv->_current_shuffled_index;
#line 405 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp42_ > 0) {
#line 2347 "PlaybackManager.c"
						gint _tmp43_;
						GeeHashMap* _tmp44_;
						gint _tmp45_;
						gint _tmp46_;
#line 405 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp43_ = self->priv->_current_shuffled_index;
#line 405 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp44_ = self->priv->_current_shuffled;
#line 405 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp45_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp44_);
#line 405 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp46_ = _tmp45_;
#line 405 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp41_ = _tmp43_ < _tmp46_;
#line 2362 "PlaybackManager.c"
					} else {
#line 405 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp41_ = FALSE;
#line 2366 "PlaybackManager.c"
					}
#line 405 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp41_) {
#line 2370 "PlaybackManager.c"
						gboolean _tmp47_ = FALSE;
						NoiseSettingsMain* _tmp48_;
						NoiseSettingsRepeat _tmp49_;
						NoiseSettingsRepeat _tmp50_;
						GeeHashMap* _tmp102_;
						gint _tmp103_;
						gpointer _tmp104_;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp48_ = main_settings;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp49_ = noise_settings_main_get_repeat_mode (_tmp48_);
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp50_ = _tmp49_;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp50_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 2386 "PlaybackManager.c"
							GeeHashMap* _tmp51_;
							gint _tmp52_;
							gpointer _tmp53_;
							NoiseMedia* _tmp54_;
							const gchar* _tmp55_;
							const gchar* _tmp56_;
							GeeHashMap* _tmp57_;
							gint _tmp58_;
							gpointer _tmp59_;
							NoiseMedia* _tmp60_;
							const gchar* _tmp61_;
							const gchar* _tmp62_;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp51_ = self->priv->_current_shuffled;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp52_ = self->priv->_current_shuffled_index;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp53_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp51_, (gpointer) ((gintptr) (_tmp52_ - 1)));
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp54_ = (NoiseMedia*) _tmp53_;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp55_ = noise_media_get_artist (_tmp54_);
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp56_ = _tmp55_;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp57_ = self->priv->_current_shuffled;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp58_ = self->priv->_current_shuffled_index;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp59_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp57_, (gpointer) ((gintptr) _tmp58_));
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp60_ = (NoiseMedia*) _tmp59_;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp61_ = noise_media_get_artist (_tmp60_);
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp62_ = _tmp61_;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp47_ = g_strcmp0 (_tmp56_, _tmp62_) != 0;
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (_tmp60_);
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (_tmp54_);
#line 2429 "PlaybackManager.c"
						} else {
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp47_ = FALSE;
#line 2433 "PlaybackManager.c"
						}
#line 407 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp47_) {
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							while (TRUE) {
#line 2439 "PlaybackManager.c"
								GeeHashMap* _tmp63_;
								gint _tmp64_;
								gpointer _tmp65_;
								NoiseMedia* _tmp66_;
								const gchar* _tmp67_;
								const gchar* _tmp68_;
								NoiseMedia* _tmp69_;
								const gchar* _tmp70_;
								const gchar* _tmp71_;
								gboolean _tmp72_;
								gint _tmp73_;
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp63_ = self->priv->_current_shuffled;
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp64_ = self->priv->_current_shuffled_index;
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp65_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp63_, (gpointer) ((gintptr) (_tmp64_ + 1)));
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp66_ = (NoiseMedia*) _tmp65_;
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp67_ = noise_media_get_artist (_tmp66_);
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp68_ = _tmp67_;
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp69_ = self->priv->_current_media;
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp70_ = noise_media_get_artist (_tmp69_);
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp71_ = _tmp70_;
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp72_ = !(g_strcmp0 (_tmp68_, _tmp71_) == 0);
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_g_object_unref0 (_tmp66_);
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								if (_tmp72_) {
#line 408 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									break;
#line 2477 "PlaybackManager.c"
								}
#line 409 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp73_ = self->priv->_current_shuffled_index;
#line 409 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp73_ + 1;
#line 2483 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp74_ = FALSE;
							NoiseSettingsMain* _tmp75_;
							NoiseSettingsRepeat _tmp76_;
							NoiseSettingsRepeat _tmp77_;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp75_ = main_settings;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp76_ = noise_settings_main_get_repeat_mode (_tmp75_);
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp77_ = _tmp76_;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (_tmp77_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 2498 "PlaybackManager.c"
								GeeHashMap* _tmp78_;
								gint _tmp79_;
								gpointer _tmp80_;
								NoiseMedia* _tmp81_;
								const gchar* _tmp82_;
								const gchar* _tmp83_;
								GeeHashMap* _tmp84_;
								gint _tmp85_;
								gpointer _tmp86_;
								NoiseMedia* _tmp87_;
								const gchar* _tmp88_;
								const gchar* _tmp89_;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp78_ = self->priv->_current_shuffled;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp79_ = self->priv->_current_shuffled_index;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp80_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp78_, (gpointer) ((gintptr) (_tmp79_ - 1)));
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp81_ = (NoiseMedia*) _tmp80_;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp82_ = noise_media_get_album (_tmp81_);
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp83_ = _tmp82_;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp84_ = self->priv->_current_shuffled;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp85_ = self->priv->_current_shuffled_index;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp86_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp84_, (gpointer) ((gintptr) _tmp85_));
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp87_ = (NoiseMedia*) _tmp86_;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp88_ = noise_media_get_album (_tmp87_);
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp89_ = _tmp88_;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp74_ = g_strcmp0 (_tmp83_, _tmp89_) != 0;
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_g_object_unref0 (_tmp87_);
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_g_object_unref0 (_tmp81_);
#line 2541 "PlaybackManager.c"
							} else {
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp74_ = FALSE;
#line 2545 "PlaybackManager.c"
							}
#line 410 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (_tmp74_) {
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								while (TRUE) {
#line 2551 "PlaybackManager.c"
									GeeHashMap* _tmp90_;
									gint _tmp91_;
									gpointer _tmp92_;
									NoiseMedia* _tmp93_;
									const gchar* _tmp94_;
									const gchar* _tmp95_;
									NoiseMedia* _tmp96_;
									const gchar* _tmp97_;
									const gchar* _tmp98_;
									gboolean _tmp99_;
									gint _tmp100_;
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp90_ = self->priv->_current_shuffled;
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp91_ = self->priv->_current_shuffled_index;
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp92_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp90_, (gpointer) ((gintptr) (_tmp91_ + 1)));
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp93_ = (NoiseMedia*) _tmp92_;
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp94_ = noise_media_get_album (_tmp93_);
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp95_ = _tmp94_;
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp96_ = self->priv->_current_media;
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp97_ = noise_media_get_album (_tmp96_);
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp98_ = _tmp97_;
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp99_ = !(g_strcmp0 (_tmp95_, _tmp98_) == 0);
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_g_object_unref0 (_tmp93_);
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									if (_tmp99_) {
#line 411 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										break;
#line 2589 "PlaybackManager.c"
									}
#line 412 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp100_ = self->priv->_current_shuffled_index;
#line 412 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = _tmp100_ + 1;
#line 2595 "PlaybackManager.c"
								}
							} else {
								gint _tmp101_;
#line 414 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp101_ = self->priv->_current_shuffled_index;
#line 414 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp101_ - 1;
#line 2603 "PlaybackManager.c"
							}
						}
#line 416 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp102_ = self->priv->_current_shuffled;
#line 416 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp103_ = self->priv->_current_shuffled_index;
#line 416 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp104_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp102_, (gpointer) ((gintptr) _tmp103_));
#line 416 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 416 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp104_;
#line 2616 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp105_;
						gint _tmp106_;
						gint _tmp107_;
						GeeHashMap* _tmp108_;
						gint _tmp109_;
						gpointer _tmp110_;
#line 418 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp105_ = self->priv->_current_shuffled;
#line 418 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp106_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp105_);
#line 418 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp107_ = _tmp106_;
#line 418 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = _tmp107_ - 1;
#line 419 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp108_ = self->priv->_current_shuffled;
#line 419 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp109_ = self->priv->_current_shuffled_index;
#line 419 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp110_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp108_, (gpointer) ((gintptr) _tmp109_));
#line 419 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 419 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp110_;
#line 2642 "PlaybackManager.c"
					}
				}
			}
		}
	} else {
		NoiseMedia* _tmp111_;
#line 422 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 424 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp111_ = self->priv->_current_media;
#line 424 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		if (_tmp111_ == NULL) {
#line 2655 "PlaybackManager.c"
			GeeHashMap* _tmp112_;
			gint _tmp113_;
			gint _tmp114_;
			GeeHashMap* _tmp115_;
			gint _tmp116_;
			gpointer _tmp117_;
#line 425 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp112_ = self->priv->_current;
#line 425 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp113_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp112_);
#line 425 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp114_ = _tmp113_;
#line 425 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			self->priv->_current_index = _tmp114_ - 1;
#line 426 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp115_ = self->priv->_current;
#line 426 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp116_ = self->priv->_current_index;
#line 426 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp117_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp115_, (gpointer) ((gintptr) _tmp116_));
#line 426 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 426 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp117_;
#line 2680 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp118_;
			NoiseSettingsRepeat _tmp119_;
			NoiseSettingsRepeat _tmp120_;
#line 427 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp118_ = main_settings;
#line 427 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp119_ = noise_settings_main_get_repeat_mode (_tmp118_);
#line 427 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp120_ = _tmp119_;
#line 427 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			if (_tmp120_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 2693 "PlaybackManager.c"
				GeeHashMap* _tmp121_;
				gint _tmp122_;
				gpointer _tmp123_;
#line 428 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp121_ = self->priv->_current;
#line 428 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp122_ = self->priv->_current_index;
#line 428 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp123_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp121_, (gpointer) ((gintptr) _tmp122_));
#line 428 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 428 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp123_;
#line 2707 "PlaybackManager.c"
			} else {
				gint _tmp124_;
#line 429 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp124_ = self->priv->_current_index;
#line 429 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (_tmp124_ == 0) {
#line 2714 "PlaybackManager.c"
					NoiseSettingsMain* _tmp125_;
					NoiseSettingsRepeat _tmp126_;
					NoiseSettingsRepeat _tmp127_;
					GeeHashMap* _tmp131_;
					gint _tmp132_;
					gpointer _tmp133_;
#line 430 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp125_ = main_settings;
#line 430 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp126_ = noise_settings_main_get_repeat_mode (_tmp125_);
#line 430 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp127_ = _tmp126_;
#line 430 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp127_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 2729 "PlaybackManager.c"
						GeeHashMap* _tmp128_;
						gint _tmp129_;
						gint _tmp130_;
#line 431 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp128_ = self->priv->_current;
#line 431 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp129_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp128_);
#line 431 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp130_ = _tmp129_;
#line 431 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						self->priv->_current_index = _tmp130_ - 1;
#line 2741 "PlaybackManager.c"
					} else {
#line 433 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						noise_playback_manager_stop_playback (self);
#line 434 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						result = NULL;
#line 434 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 434 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 434 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						return result;
#line 2753 "PlaybackManager.c"
					}
#line 437 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp131_ = self->priv->_current;
#line 437 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp132_ = self->priv->_current_index;
#line 437 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp133_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp131_, (gpointer) ((gintptr) _tmp132_));
#line 437 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 437 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp133_;
#line 2765 "PlaybackManager.c"
				} else {
					gboolean _tmp134_ = FALSE;
					gint _tmp135_;
#line 438 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp135_ = self->priv->_current_index;
#line 438 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp135_ > 0) {
#line 2773 "PlaybackManager.c"
						gint _tmp136_;
						GeeHashMap* _tmp137_;
						gint _tmp138_;
						gint _tmp139_;
#line 438 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp136_ = self->priv->_current_index;
#line 438 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp137_ = self->priv->_current;
#line 438 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp138_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp137_);
#line 438 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp139_ = _tmp138_;
#line 438 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp134_ = _tmp136_ < _tmp139_;
#line 2788 "PlaybackManager.c"
					} else {
#line 438 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp134_ = FALSE;
#line 2792 "PlaybackManager.c"
					}
#line 438 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp134_) {
#line 2796 "PlaybackManager.c"
						gboolean _tmp140_ = FALSE;
						NoiseSettingsMain* _tmp141_;
						NoiseSettingsRepeat _tmp142_;
						NoiseSettingsRepeat _tmp143_;
						GeeHashMap* _tmp195_;
						gint _tmp196_;
						gpointer _tmp197_;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp141_ = main_settings;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp142_ = noise_settings_main_get_repeat_mode (_tmp141_);
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp143_ = _tmp142_;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp143_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 2812 "PlaybackManager.c"
							GeeHashMap* _tmp144_;
							gint _tmp145_;
							gpointer _tmp146_;
							NoiseMedia* _tmp147_;
							const gchar* _tmp148_;
							const gchar* _tmp149_;
							GeeHashMap* _tmp150_;
							gint _tmp151_;
							gpointer _tmp152_;
							NoiseMedia* _tmp153_;
							const gchar* _tmp154_;
							const gchar* _tmp155_;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp144_ = self->priv->_current;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp145_ = self->priv->_current_index;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp146_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp144_, (gpointer) ((gintptr) (_tmp145_ - 1)));
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp147_ = (NoiseMedia*) _tmp146_;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp148_ = noise_media_get_artist (_tmp147_);
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp149_ = _tmp148_;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp150_ = self->priv->_current;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp151_ = self->priv->_current_index;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp152_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp150_, (gpointer) ((gintptr) _tmp151_));
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp153_ = (NoiseMedia*) _tmp152_;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp154_ = noise_media_get_artist (_tmp153_);
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp155_ = _tmp154_;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp140_ = g_strcmp0 (_tmp149_, _tmp155_) != 0;
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (_tmp153_);
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (_tmp147_);
#line 2855 "PlaybackManager.c"
						} else {
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp140_ = FALSE;
#line 2859 "PlaybackManager.c"
						}
#line 441 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (_tmp140_) {
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							while (TRUE) {
#line 2865 "PlaybackManager.c"
								GeeHashMap* _tmp156_;
								gint _tmp157_;
								gpointer _tmp158_;
								NoiseMedia* _tmp159_;
								const gchar* _tmp160_;
								const gchar* _tmp161_;
								NoiseMedia* _tmp162_;
								const gchar* _tmp163_;
								const gchar* _tmp164_;
								gboolean _tmp165_;
								gint _tmp166_;
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp156_ = self->priv->_current;
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp157_ = self->priv->_current_index;
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp158_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp156_, (gpointer) ((gintptr) (_tmp157_ + 1)));
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp159_ = (NoiseMedia*) _tmp158_;
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp160_ = noise_media_get_artist (_tmp159_);
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp161_ = _tmp160_;
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp162_ = self->priv->_current_media;
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp163_ = noise_media_get_artist (_tmp162_);
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp164_ = _tmp163_;
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp165_ = !(g_strcmp0 (_tmp161_, _tmp164_) == 0);
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_g_object_unref0 (_tmp159_);
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								if (_tmp165_) {
#line 442 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									break;
#line 2903 "PlaybackManager.c"
								}
#line 443 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp166_ = self->priv->_current_index;
#line 443 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								self->priv->_current_index = _tmp166_ + 1;
#line 2909 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp167_ = FALSE;
							NoiseSettingsMain* _tmp168_;
							NoiseSettingsRepeat _tmp169_;
							NoiseSettingsRepeat _tmp170_;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp168_ = main_settings;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp169_ = noise_settings_main_get_repeat_mode (_tmp168_);
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp170_ = _tmp169_;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (_tmp170_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 2924 "PlaybackManager.c"
								GeeHashMap* _tmp171_;
								gint _tmp172_;
								gpointer _tmp173_;
								NoiseMedia* _tmp174_;
								const gchar* _tmp175_;
								const gchar* _tmp176_;
								GeeHashMap* _tmp177_;
								gint _tmp178_;
								gpointer _tmp179_;
								NoiseMedia* _tmp180_;
								const gchar* _tmp181_;
								const gchar* _tmp182_;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp171_ = self->priv->_current;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp172_ = self->priv->_current_index;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp173_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp171_, (gpointer) ((gintptr) (_tmp172_ - 1)));
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp174_ = (NoiseMedia*) _tmp173_;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp175_ = noise_media_get_album (_tmp174_);
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp176_ = _tmp175_;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp177_ = self->priv->_current;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp178_ = self->priv->_current_index;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp179_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp177_, (gpointer) ((gintptr) _tmp178_));
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp180_ = (NoiseMedia*) _tmp179_;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp181_ = noise_media_get_album (_tmp180_);
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp182_ = _tmp181_;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp167_ = g_strcmp0 (_tmp176_, _tmp182_) != 0;
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_g_object_unref0 (_tmp180_);
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_g_object_unref0 (_tmp174_);
#line 2967 "PlaybackManager.c"
							} else {
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp167_ = FALSE;
#line 2971 "PlaybackManager.c"
							}
#line 444 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (_tmp167_) {
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								while (TRUE) {
#line 2977 "PlaybackManager.c"
									GeeHashMap* _tmp183_;
									gint _tmp184_;
									gpointer _tmp185_;
									NoiseMedia* _tmp186_;
									const gchar* _tmp187_;
									const gchar* _tmp188_;
									NoiseMedia* _tmp189_;
									const gchar* _tmp190_;
									const gchar* _tmp191_;
									gboolean _tmp192_;
									gint _tmp193_;
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp183_ = self->priv->_current;
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp184_ = self->priv->_current_index;
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp185_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp183_, (gpointer) ((gintptr) (_tmp184_ + 1)));
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp186_ = (NoiseMedia*) _tmp185_;
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp187_ = noise_media_get_album (_tmp186_);
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp188_ = _tmp187_;
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp189_ = self->priv->_current_media;
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp190_ = noise_media_get_album (_tmp189_);
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp191_ = _tmp190_;
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp192_ = !(g_strcmp0 (_tmp188_, _tmp191_) == 0);
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_g_object_unref0 (_tmp186_);
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									if (_tmp192_) {
#line 445 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										break;
#line 3015 "PlaybackManager.c"
									}
#line 446 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp193_ = self->priv->_current_index;
#line 446 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									self->priv->_current_index = _tmp193_ + 1;
#line 3021 "PlaybackManager.c"
								}
							} else {
								gint _tmp194_;
#line 448 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp194_ = self->priv->_current_index;
#line 448 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								self->priv->_current_index = _tmp194_ - 1;
#line 3029 "PlaybackManager.c"
							}
						}
#line 450 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp195_ = self->priv->_current;
#line 450 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp196_ = self->priv->_current_index;
#line 450 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp197_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp195_, (gpointer) ((gintptr) _tmp196_));
#line 450 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 450 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp197_;
#line 3042 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp209_;
						gint _tmp210_;
						gint _tmp211_;
						GeeHashMap* _tmp212_;
						gint _tmp213_;
						gpointer _tmp214_;
						{
							GeeIterator* _s_it = NULL;
							NoiseLibrary* _tmp198_;
							NoiseLibrary* _tmp199_;
							GeeCollection* _tmp200_;
							GeeCollection* _tmp201_;
							GeeIterator* _tmp202_;
							GeeIterator* _tmp203_;
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp198_ = noise_playback_manager_get_library (self);
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp199_ = _tmp198_;
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp200_ = noise_library_get_medias (_tmp199_);
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp201_ = _tmp200_;
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp202_ = gee_iterable_iterator ((GeeIterable*) _tmp201_);
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp203_ = _tmp202_;
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (_tmp201_);
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_s_it = _tmp203_;
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							while (TRUE) {
#line 3076 "PlaybackManager.c"
								GeeIterator* _tmp204_;
								gboolean _tmp205_;
								NoiseMedia* s = NULL;
								GeeIterator* _tmp206_;
								gpointer _tmp207_;
								NoiseMedia* _tmp208_;
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp204_ = _s_it;
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp205_ = gee_iterator_next (_tmp204_);
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								if (!_tmp205_) {
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									break;
#line 3091 "PlaybackManager.c"
								}
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp206_ = _s_it;
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp207_ = gee_iterator_get (_tmp206_);
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								s = (NoiseMedia*) _tmp207_;
#line 453 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp208_ = s;
#line 453 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								noise_playback_manager_addToCurrent (self, _tmp208_);
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_g_object_unref0 (s);
#line 3105 "PlaybackManager.c"
							}
#line 452 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_object_unref0 (_s_it);
#line 3109 "PlaybackManager.c"
						}
#line 455 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp209_ = self->priv->_current;
#line 455 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp210_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp209_);
#line 455 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp211_ = _tmp210_;
#line 455 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						self->priv->_current_index = _tmp211_ - 1;
#line 456 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp212_ = self->priv->_current;
#line 456 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp213_ = self->priv->_current_index;
#line 456 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp214_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp212_, (gpointer) ((gintptr) _tmp213_));
#line 456 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 456 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp214_;
#line 3129 "PlaybackManager.c"
					}
				}
			}
		}
	}
#line 460 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp215_ = play;
#line 460 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp215_) {
#line 3139 "PlaybackManager.c"
		NoiseMedia* _tmp216_;
#line 461 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp216_ = rv;
#line 461 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_playback_manager_playMedia (self, _tmp216_, FALSE);
#line 3145 "PlaybackManager.c"
	}
#line 465 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	result = rv;
#line 465 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 465 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 3153 "PlaybackManager.c"
}


static Block8Data* block8_data_ref (Block8Data* _data8_) {
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return _data8_;
#line 3162 "PlaybackManager.c"
}


static void block8_data_unref (void * _userdata_) {
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 3171 "PlaybackManager.c"
		NoisePlaybackManager* self;
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		self = _data8_->self;
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (_data8_->m);
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (self);
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		g_slice_free (Block8Data, _data8_);
#line 3181 "PlaybackManager.c"
	}
}


static gboolean __lambda27_ (Block8Data* _data8_) {
	NoisePlaybackManager* self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	NoiseMedia* _tmp1_;
#line 559 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self = _data8_->self;
#line 560 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = _data8_->m;
#line 560 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp1_ != NULL) {
#line 3197 "PlaybackManager.c"
		NoiseMedia* _tmp2_;
		NoiseMedia* _tmp3_;
#line 560 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_media;
#line 560 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp3_ = _data8_->m;
#line 560 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp0_ = _tmp2_ == _tmp3_;
#line 3206 "PlaybackManager.c"
	} else {
#line 560 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp0_ = FALSE;
#line 3210 "PlaybackManager.c"
	}
#line 560 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp0_) {
#line 3214 "PlaybackManager.c"
		NoiseHistoryPlaylist* _tmp4_;
		NoiseMedia* _tmp5_;
		guint player_duration_s = 0U;
		NoisePlayback* _tmp6_;
		gint64 _tmp7_;
		guint _tmp8_;
#line 561 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp4_ = self->history_playlist;
#line 561 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp5_ = _data8_->m;
#line 561 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_playlist_add_media ((NoisePlaylist*) _tmp4_, _tmp5_);
#line 563 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp6_ = self->player;
#line 563 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp7_ = noise_playback_get_duration (_tmp6_);
#line 563 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		player_duration_s = (guint) (_tmp7_ / NOISE_TIME_UTILS_NANO_INV);
#line 564 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp8_ = player_duration_s;
#line 564 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		if (_tmp8_ > ((guint) 1)) {
#line 3237 "PlaybackManager.c"
			gint delta_s = 0;
			guint _tmp9_;
			NoiseMedia* _tmp10_;
			guint _tmp11_;
			guint _tmp12_;
			gint _tmp13_;
			gdouble _tmp14_;
#line 565 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp9_ = player_duration_s;
#line 565 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp10_ = _data8_->m;
#line 565 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp11_ = noise_media_get_length (_tmp10_);
#line 565 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp12_ = _tmp11_;
#line 565 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			delta_s = ((gint) _tmp9_) - ((gint) (_tmp12_ / NOISE_TIME_UTILS_MILI_INV));
#line 566 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp13_ = delta_s;
#line 566 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp14_ = fabs ((gdouble) _tmp13_);
#line 566 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			if (_tmp14_ > ((gdouble) 3)) {
#line 3261 "PlaybackManager.c"
				NoiseMedia* _tmp15_;
				guint _tmp16_;
				NoiseLibrary* _tmp17_;
				NoiseLibrary* _tmp18_;
				NoiseMedia* _tmp19_;
#line 567 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp15_ = _data8_->m;
#line 567 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp16_ = player_duration_s;
#line 567 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				noise_media_set_length (_tmp15_, (guint) (_tmp16_ * NOISE_TIME_UTILS_MILI_INV));
#line 568 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp17_ = noise_playback_manager_get_library (self);
#line 568 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp18_ = _tmp17_;
#line 568 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp19_ = _data8_->m;
#line 568 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				noise_library_update_media (_tmp18_, _tmp19_, FALSE, FALSE);
#line 3281 "PlaybackManager.c"
			}
		}
	}
#line 573 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	result = FALSE;
#line 573 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 3289 "PlaybackManager.c"
}


static gboolean ___lambda27__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda27_ (self);
#line 559 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 3298 "PlaybackManager.c"
}


void noise_playback_manager_playMedia (NoisePlaybackManager* self, NoiseMedia* m, gboolean use_resume_pos) {
	Block8Data* _data8_;
	NoiseMedia* _tmp0_;
	NoiseMedia* _tmp1_;
	gint64 old_id = 0LL;
	NoiseMedia* _tmp2_;
	NoiseMedia* _tmp6_;
	NoiseMedia* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean found = FALSE;
	gboolean _tmp51_;
	NoiseMedia* _tmp57_;
	GFile* _tmp58_;
	GFile* _tmp59_;
	gboolean _tmp60_;
	gint _tmp76_;
	gboolean _tmp79_;
	gboolean _tmp81_ = FALSE;
	NoiseMedia* _tmp82_;
	gint64 _tmp83_;
	gint64 _tmp84_;
	NoiseMedia* _tmp93_;
	NoiseMedia* _tmp95_;
	NoiseMedia* _tmp96_;
	NoiseMedia* _tmp97_;
	gboolean _tmp98_;
	GError * _inner_error_ = NULL;
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (m != NULL);
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_data8_->_ref_count_ = 1;
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_data8_->self = g_object_ref (self);
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = m;
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (_data8_->m);
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_data8_->m = _tmp1_;
#line 470 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	old_id = (gint64) -1;
#line 473 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = self->priv->_current_media;
#line 473 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp2_ != NULL) {
#line 3354 "PlaybackManager.c"
		NoiseMedia* _tmp3_;
		gint64 _tmp4_;
		gint64 _tmp5_;
#line 474 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp3_ = self->priv->_current_media;
#line 474 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp4_ = noise_media_get_rowid (_tmp3_);
#line 474 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp5_ = _tmp4_;
#line 474 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		old_id = _tmp5_;
#line 3366 "PlaybackManager.c"
	}
#line 476 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp6_ = _data8_->m;
#line 476 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_set_current_media (self, _tmp6_);
#line 480 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp7_ = _data8_->m;
#line 480 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp8_ = noise_media_get_location_unknown (_tmp7_);
#line 480 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp9_ = _tmp8_;
#line 480 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp9_) {
#line 3380 "PlaybackManager.c"
		NoiseMedia* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		GFile* _tmp14_;
		GFile* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 481 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp10_ = _data8_->m;
#line 481 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp11_ = noise_media_get_uri (_tmp10_);
#line 481 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp12_ = _tmp11_;
#line 481 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp13_ = _tmp12_;
#line 481 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp14_ = g_file_new_for_uri (_tmp13_);
#line 481 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp15_ = _tmp14_;
#line 481 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp16_ = g_file_query_exists (_tmp15_, NULL);
#line 481 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp17_ = _tmp16_;
#line 481 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (_tmp15_);
#line 481 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_free0 (_tmp13_);
#line 481 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		if (_tmp17_) {
#line 3411 "PlaybackManager.c"
			NoiseMedia* _tmp18_;
			NoiseMedia* _tmp19_;
#line 482 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp18_ = _data8_->m;
#line 482 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			noise_media_set_location_unknown (_tmp18_, FALSE);
#line 483 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp19_ = _data8_->m;
#line 483 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			noise_media_set_unique_status_image (_tmp19_, NULL);
#line 3422 "PlaybackManager.c"
		} else {
#line 486 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			noise_playback_manager_stop_playback (self);
#line 487 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			block8_data_unref (_data8_);
#line 487 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_data8_ = NULL;
#line 487 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			return;
#line 3432 "PlaybackManager.c"
		}
	}
#line 491 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	found = FALSE;
#line 3437 "PlaybackManager.c"
	{
		GeeTreeSet* _tmp20_;
#line 492 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp20_ = self->priv->playbacks;
#line 492 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		g_rec_mutex_lock (&self->priv->__lock_playbacks);
#line 3444 "PlaybackManager.c"
		{
			{
				GeeIterator* _playback_it = NULL;
				GeeTreeSet* _tmp21_;
				GeeIterator* _tmp22_;
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp21_ = self->priv->playbacks;
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp22_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp21_);
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_playback_it = _tmp22_;
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				while (TRUE) {
#line 3458 "PlaybackManager.c"
					GeeIterator* _tmp23_;
					gboolean _tmp24_;
					NoisePlayback* playback = NULL;
					GeeIterator* _tmp25_;
					gpointer _tmp26_;
					gboolean _tmp49_;
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp23_ = _playback_it;
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp24_ = gee_iterator_next (_tmp23_);
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (!_tmp24_) {
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						break;
#line 3473 "PlaybackManager.c"
					}
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp25_ = _playback_it;
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp26_ = gee_iterator_get (_tmp25_);
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					playback = (NoisePlayback*) _tmp26_;
#line 3481 "PlaybackManager.c"
					{
						GeeIterator* _supported_uri_it = NULL;
						NoisePlayback* _tmp27_;
						GeeCollection* _tmp28_;
						GeeCollection* _tmp29_;
						GeeIterator* _tmp30_;
						GeeIterator* _tmp31_;
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp27_ = playback;
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp28_ = noise_playback_get_supported_uri (_tmp27_);
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp29_ = _tmp28_;
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp30_ = gee_iterable_iterator ((GeeIterable*) _tmp29_);
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp31_ = _tmp30_;
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (_tmp29_);
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_supported_uri_it = _tmp31_;
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						while (TRUE) {
#line 3505 "PlaybackManager.c"
							GeeIterator* _tmp32_;
							gboolean _tmp33_;
							gchar* supported_uri = NULL;
							GeeIterator* _tmp34_;
							gpointer _tmp35_;
							NoiseMedia* _tmp36_;
							gchar* _tmp37_;
							gchar* _tmp38_;
							gchar* _tmp39_;
							const gchar* _tmp40_;
							gboolean _tmp41_;
							gboolean _tmp42_;
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp32_ = _supported_uri_it;
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp33_ = gee_iterator_next (_tmp32_);
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (!_tmp33_) {
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								break;
#line 3526 "PlaybackManager.c"
							}
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp34_ = _supported_uri_it;
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp35_ = gee_iterator_get (_tmp34_);
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							supported_uri = (gchar*) _tmp35_;
#line 495 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp36_ = _data8_->m;
#line 495 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp37_ = noise_media_get_uri (_tmp36_);
#line 495 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp38_ = _tmp37_;
#line 495 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp39_ = _tmp38_;
#line 495 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp40_ = supported_uri;
#line 495 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp41_ = g_str_has_prefix (_tmp39_, _tmp40_);
#line 495 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp42_ = _tmp41_;
#line 495 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_free0 (_tmp39_);
#line 495 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							if (_tmp42_) {
#line 3552 "PlaybackManager.c"
								NoisePlayback* _tmp43_;
								gdouble _tmp44_;
								NoisePlayback* _tmp45_;
								NoisePlayback* _tmp46_;
								NoisePlayback* _tmp47_;
								gdouble _tmp48_;
#line 496 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp43_ = self->player;
#line 496 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp44_ = noise_playback_get_volume (_tmp43_);
#line 496 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								self->priv->saved_volume = _tmp44_;
#line 497 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL], 0);
#line 498 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp45_ = self->player;
#line 498 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								noise_playback_set_state (_tmp45_, GST_STATE_NULL);
#line 499 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								found = TRUE;
#line 500 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp46_ = playback;
#line 500 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp47_ = _g_object_ref0 (_tmp46_);
#line 500 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_g_object_unref0 (self->player);
#line 500 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								self->player = _tmp47_;
#line 501 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp48_ = self->priv->saved_volume;
#line 501 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								noise_playback_manager_set_volume (self, _tmp48_);
#line 502 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL], 0);
#line 503 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_g_free0 (supported_uri);
#line 503 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								break;
#line 3591 "PlaybackManager.c"
							}
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_g_free0 (supported_uri);
#line 3595 "PlaybackManager.c"
						}
#line 494 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (_supported_uri_it);
#line 3599 "PlaybackManager.c"
					}
#line 506 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp49_ = found;
#line 506 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp49_ == TRUE) {
#line 507 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						break;
#line 3607 "PlaybackManager.c"
					}
				}
#line 493 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_g_object_unref0 (_playback_it);
#line 3612 "PlaybackManager.c"
			}
		}
		__finally7:
		{
			GeeTreeSet* _tmp50_;
#line 492 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp50_ = self->priv->playbacks;
#line 492 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			g_rec_mutex_unlock (&self->priv->__lock_playbacks);
#line 3622 "PlaybackManager.c"
		}
#line 492 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 492 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			block8_data_unref (_data8_);
#line 492 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_data8_ = NULL;
#line 492 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 492 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			g_clear_error (&_inner_error_);
#line 492 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			return;
#line 3636 "PlaybackManager.c"
		}
	}
#line 511 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp51_ = found;
#line 511 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp51_ == FALSE) {
#line 3643 "PlaybackManager.c"
		NoiseMedia* _tmp52_;
		GThemedIcon* _tmp53_;
		GThemedIcon* _tmp54_;
		NoiseMedia* _tmp55_;
		NoiseMedia* _tmp56_;
#line 512 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp52_ = _data8_->m;
#line 512 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp53_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 512 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp54_ = _tmp53_;
#line 512 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_media_set_unique_status_image (_tmp52_, (GIcon*) _tmp54_);
#line 512 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (_tmp54_);
#line 513 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp55_ = noise_playback_manager_getNext (self, TRUE);
#line 513 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp56_ = _tmp55_;
#line 513 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (_tmp56_);
#line 514 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		block8_data_unref (_data8_);
#line 514 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_data8_ = NULL;
#line 514 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		return;
#line 3671 "PlaybackManager.c"
	}
#line 518 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp57_ = _data8_->m;
#line 518 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp58_ = noise_media_get_file (_tmp57_);
#line 518 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp59_ = _tmp58_;
#line 518 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp60_ = g_file_query_exists (_tmp59_, NULL);
#line 518 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (!_tmp60_) {
#line 3683 "PlaybackManager.c"
		NoiseMedia* _tmp61_;
		GThemedIcon* _tmp62_;
		GThemedIcon* _tmp63_;
		NoiseMedia* _tmp64_;
		NoiseMedia* _tmp65_;
		NoiseMedia* _tmp66_;
#line 519 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp61_ = _data8_->m;
#line 519 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp62_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 519 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp63_ = _tmp62_;
#line 519 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_media_set_unique_status_image (_tmp61_, (GIcon*) _tmp63_);
#line 519 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (_tmp63_);
#line 520 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp64_ = _data8_->m;
#line 520 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_media_set_location_unknown (_tmp64_, TRUE);
#line 522 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp65_ = noise_playback_manager_getNext (self, TRUE);
#line 522 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp66_ = _tmp65_;
#line 522 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (_tmp66_);
#line 523 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		block8_data_unref (_data8_);
#line 523 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_data8_ = NULL;
#line 523 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		return;
#line 3716 "PlaybackManager.c"
	} else {
		gboolean _tmp67_ = FALSE;
		NoiseMedia* _tmp68_;
		gboolean _tmp69_;
		gboolean _tmp70_;
#line 525 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp68_ = _data8_->m;
#line 525 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp69_ = noise_media_get_location_unknown (_tmp68_);
#line 525 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp70_ = _tmp69_;
#line 525 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		if (_tmp70_) {
#line 3730 "PlaybackManager.c"
			NoiseMedia* _tmp71_;
			GIcon* _tmp72_;
			GIcon* _tmp73_;
#line 525 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp71_ = _data8_->m;
#line 525 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp72_ = noise_media_get_unique_status_image (_tmp71_);
#line 525 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp73_ = _tmp72_;
#line 525 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp67_ = _tmp73_ != NULL;
#line 3742 "PlaybackManager.c"
		} else {
#line 525 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp67_ = FALSE;
#line 3746 "PlaybackManager.c"
		}
#line 525 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		if (_tmp67_) {
#line 3750 "PlaybackManager.c"
			NoiseMedia* _tmp74_;
			NoiseMedia* _tmp75_;
#line 526 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp74_ = _data8_->m;
#line 526 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			noise_media_set_unique_status_image (_tmp74_, NULL);
#line 527 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp75_ = _data8_->m;
#line 527 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			noise_media_set_location_unknown (_tmp75_, FALSE);
#line 3761 "PlaybackManager.c"
		}
	}
#line 531 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_change_gains_thread (self);
#line 535 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp76_ = self->next_gapless_id;
#line 535 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp76_ == 0) {
#line 3770 "PlaybackManager.c"
		NoisePlayback* _tmp77_;
		NoiseMedia* _tmp78_;
#line 536 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp77_ = self->player;
#line 536 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp78_ = _data8_->m;
#line 536 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_playback_set_media (_tmp77_, _tmp78_);
#line 3779 "PlaybackManager.c"
	} else {
#line 539 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		self->next_gapless_id = 0;
#line 3783 "PlaybackManager.c"
	}
#line 543 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp79_ = self->priv->_playing;
#line 543 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (!_tmp79_) {
#line 3789 "PlaybackManager.c"
		NoisePlayback* _tmp80_;
#line 544 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp80_ = self->player;
#line 544 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_playback_pause (_tmp80_);
#line 3795 "PlaybackManager.c"
	}
#line 547 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp82_ = _data8_->m;
#line 547 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp83_ = noise_media_get_rowid (_tmp82_);
#line 547 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp84_ = _tmp83_;
#line 547 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp84_ >= ((gint64) 0)) {
#line 3805 "PlaybackManager.c"
		NoiseSettingsMain* _tmp85_;
		NoiseSettingsMain* _tmp86_;
		gboolean _tmp87_;
#line 547 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp85_ = noise_settings_main_get_default ();
#line 547 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp86_ = _tmp85_;
#line 547 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp87_ = noise_settings_main_privacy_mode_enabled (_tmp86_);
#line 547 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp81_ = !_tmp87_;
#line 547 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (_tmp86_);
#line 3819 "PlaybackManager.c"
	} else {
#line 547 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp81_ = FALSE;
#line 3823 "PlaybackManager.c"
	}
#line 547 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp81_) {
#line 3827 "PlaybackManager.c"
		NoiseSettingsMain* _tmp88_;
		NoiseSettingsMain* _tmp89_;
		NoiseMedia* _tmp90_;
		gint64 _tmp91_;
		gint64 _tmp92_;
#line 548 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp88_ = noise_settings_main_get_default ();
#line 548 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp89_ = _tmp88_;
#line 548 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp90_ = _data8_->m;
#line 548 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp91_ = noise_media_get_rowid (_tmp90_);
#line 548 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp92_ = _tmp91_;
#line 548 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_settings_main_set_last_media_playing (_tmp89_, _tmp92_);
#line 548 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (_tmp89_);
#line 3847 "PlaybackManager.c"
	}
#line 551 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp93_ = _data8_->m;
#line 551 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp93_ != NULL) {
#line 3853 "PlaybackManager.c"
		NoiseMedia* _tmp94_;
#line 552 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp94_ = _data8_->m;
#line 552 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL], 0, _tmp94_);
#line 3859 "PlaybackManager.c"
	}
#line 555 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp95_ = _data8_->m;
#line 555 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp96_ = noise_playback_manager_peek_queue (self);
#line 555 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp97_ = _tmp96_;
#line 555 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp98_ = _tmp95_ == _tmp97_;
#line 555 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (_tmp97_);
#line 555 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp98_) {
#line 3873 "PlaybackManager.c"
		NoiseMedia* _tmp99_;
		NoiseMedia* _tmp100_;
#line 556 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp99_ = noise_playback_manager_poll_queue (self);
#line 556 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp100_ = _tmp99_;
#line 556 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (_tmp100_);
#line 3882 "PlaybackManager.c"
	}
#line 559 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda27__gsource_func, block8_data_ref (_data8_), block8_data_unref);
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	block8_data_unref (_data8_);
#line 469 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_data8_ = NULL;
#line 3890 "PlaybackManager.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 1403 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1403 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1404 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1404 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1404 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1404 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 3910 "PlaybackManager.c"
}


void noise_playback_manager_change_gains_thread (NoisePlaybackManager* self) {
	NoiseSettingsEqualizer* equalizer_settings = NULL;
	NoiseSettingsEqualizer* _tmp0_;
	NoiseSettingsEqualizer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 577 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 578 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_settings_equalizer_get_default ();
#line 578 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	equalizer_settings = _tmp0_;
#line 579 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = equalizer_settings;
#line 579 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = noise_settings_equalizer_get_equalizer_enabled (_tmp1_);
#line 579 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 579 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp3_) {
#line 3934 "PlaybackManager.c"
		gboolean automatic_enabled = FALSE;
		NoiseSettingsEqualizer* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		gchar* selected_preset = NULL;
		NoiseSettingsEqualizer* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 580 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp4_ = equalizer_settings;
#line 580 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp5_ = noise_settings_equalizer_get_auto_switch_preset (_tmp4_);
#line 580 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp6_ = _tmp5_;
#line 580 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		automatic_enabled = _tmp6_;
#line 581 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp7_ = equalizer_settings;
#line 581 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp8_ = noise_settings_equalizer_get_selected_preset (_tmp7_);
#line 581 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 581 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 581 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		selected_preset = _tmp10_;
#line 3962 "PlaybackManager.c"
		{
			GeeIterator* _p_it = NULL;
			NoiseSettingsEqualizer* _tmp11_;
			GeeCollection* _tmp12_;
			GeeCollection* _tmp13_;
			GeeIterator* _tmp14_;
			GeeIterator* _tmp15_;
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp11_ = equalizer_settings;
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp12_ = noise_settings_equalizer_getPresets (_tmp11_);
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp13_ = _tmp12_;
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp15_ = _tmp14_;
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_g_object_unref0 (_tmp13_);
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_p_it = _tmp15_;
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			while (TRUE) {
#line 3986 "PlaybackManager.c"
				GeeIterator* _tmp16_;
				gboolean _tmp17_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp18_;
				gpointer _tmp19_;
				gboolean _tmp20_ = FALSE;
				NoiseEqualizerPreset* _tmp21_;
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp16_ = _p_it;
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp17_ = gee_iterator_next (_tmp16_);
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (!_tmp17_) {
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					break;
#line 4002 "PlaybackManager.c"
				}
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp18_ = _p_it;
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp19_ = gee_iterator_get (_tmp18_);
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				p = (NoiseEqualizerPreset*) _tmp19_;
#line 584 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp21_ = p;
#line 584 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (_tmp21_ != NULL) {
#line 4014 "PlaybackManager.c"
					NoiseMedia* _tmp22_;
#line 584 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp22_ = self->priv->_current_media;
#line 584 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp20_ = _tmp22_ != NULL;
#line 4020 "PlaybackManager.c"
				} else {
#line 584 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp20_ = FALSE;
#line 4024 "PlaybackManager.c"
				}
#line 584 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (_tmp20_) {
#line 4028 "PlaybackManager.c"
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp26_;
					const gchar* _tmp27_;
					const gchar* _tmp28_;
					gchar* _tmp29_;
					gboolean _tmp30_ = FALSE;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean _tmp33_;
					gboolean match_genre = FALSE;
					gboolean _tmp37_ = FALSE;
					gboolean _tmp38_ = FALSE;
					gboolean _tmp39_;
#line 585 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp23_ = p;
#line 585 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp24_ = _tmp23_->name;
#line 585 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
#line 585 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					preset_name = _tmp25_;
#line 586 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp26_ = self->priv->_current_media;
#line 586 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp27_ = noise_media_get_genre (_tmp26_);
#line 586 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp28_ = _tmp27_;
#line 586 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp29_ = g_utf8_strdown (_tmp28_, (gssize) -1);
#line 586 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					media_genre = _tmp29_;
#line 588 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp31_ = media_genre;
#line 588 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp32_ = preset_name;
#line 588 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp33_ = string_contains (_tmp31_, _tmp32_);
#line 588 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp33_) {
#line 588 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp30_ = TRUE;
#line 4074 "PlaybackManager.c"
					} else {
						const gchar* _tmp34_;
						const gchar* _tmp35_;
						gboolean _tmp36_;
#line 588 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp34_ = preset_name;
#line 588 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp35_ = media_genre;
#line 588 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp36_ = string_contains (_tmp34_, _tmp35_);
#line 588 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp30_ = _tmp36_;
#line 4087 "PlaybackManager.c"
					}
#line 588 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					match_genre = _tmp30_;
#line 590 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp39_ = automatic_enabled;
#line 590 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp39_) {
#line 4095 "PlaybackManager.c"
						gboolean _tmp40_;
#line 590 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp40_ = match_genre;
#line 590 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp38_ = _tmp40_;
#line 4101 "PlaybackManager.c"
					} else {
#line 590 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp38_ = FALSE;
#line 4105 "PlaybackManager.c"
					}
#line 590 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp38_) {
#line 590 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp37_ = TRUE;
#line 4111 "PlaybackManager.c"
					} else {
						gboolean _tmp41_ = FALSE;
						gboolean _tmp42_;
#line 591 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp42_ = automatic_enabled;
#line 591 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (!_tmp42_) {
#line 4119 "PlaybackManager.c"
							NoiseEqualizerPreset* _tmp43_;
							const gchar* _tmp44_;
							const gchar* _tmp45_;
#line 591 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp43_ = p;
#line 591 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp44_ = _tmp43_->name;
#line 591 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp45_ = selected_preset;
#line 591 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp41_ = g_strcmp0 (_tmp44_, _tmp45_) == 0;
#line 4131 "PlaybackManager.c"
						} else {
#line 591 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp41_ = FALSE;
#line 4135 "PlaybackManager.c"
						}
#line 591 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp37_ = _tmp41_;
#line 4139 "PlaybackManager.c"
					}
#line 590 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp37_) {
#line 4143 "PlaybackManager.c"
						{
							gint i = 0;
#line 593 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							i = 0;
#line 4148 "PlaybackManager.c"
							{
								gboolean _tmp46_ = FALSE;
#line 593 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp46_ = TRUE;
#line 593 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								while (TRUE) {
#line 4155 "PlaybackManager.c"
									gint _tmp48_;
									NoisePlayback* _tmp49_;
									gint _tmp50_;
									NoiseEqualizerPreset* _tmp51_;
									gint _tmp52_;
									gint _tmp53_;
#line 593 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									if (!_tmp46_) {
#line 4164 "PlaybackManager.c"
										gint _tmp47_;
#line 593 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp47_ = i;
#line 593 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										i = _tmp47_ + 1;
#line 4170 "PlaybackManager.c"
									}
#line 593 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp46_ = FALSE;
#line 593 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp48_ = i;
#line 593 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									if (!(_tmp48_ < 10)) {
#line 593 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										break;
#line 4180 "PlaybackManager.c"
									}
#line 594 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp49_ = self->player;
#line 594 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp50_ = i;
#line 594 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp51_ = p;
#line 594 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp52_ = i;
#line 594 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp53_ = noise_equalizer_preset_getGain (_tmp51_, _tmp52_);
#line 594 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									noise_playback_set_equalizer_gain (_tmp49_, _tmp50_, _tmp53_);
#line 4194 "PlaybackManager.c"
								}
							}
						}
#line 596 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_free0 (media_genre);
#line 596 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_free0 (preset_name);
#line 596 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (p);
#line 596 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (_p_it);
#line 596 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_free0 (selected_preset);
#line 596 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (equalizer_settings);
#line 596 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						return;
#line 4212 "PlaybackManager.c"
					}
#line 584 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_free0 (media_genre);
#line 584 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_free0 (preset_name);
#line 4218 "PlaybackManager.c"
				}
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_g_object_unref0 (p);
#line 4222 "PlaybackManager.c"
			}
#line 583 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_g_object_unref0 (_p_it);
#line 4226 "PlaybackManager.c"
		}
		{
			GeeIterator* _p_it = NULL;
			GeeCollection* _tmp54_;
			GeeCollection* _tmp55_;
			GeeIterator* _tmp56_;
			GeeIterator* _tmp57_;
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp54_ = noise_equalizer_get_default_presets ();
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp55_ = _tmp54_;
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp56_ = gee_iterable_iterator ((GeeIterable*) _tmp55_);
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp57_ = _tmp56_;
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_g_object_unref0 (_tmp55_);
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_p_it = _tmp57_;
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			while (TRUE) {
#line 4248 "PlaybackManager.c"
				GeeIterator* _tmp58_;
				gboolean _tmp59_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp60_;
				gpointer _tmp61_;
				gboolean _tmp62_ = FALSE;
				NoiseEqualizerPreset* _tmp63_;
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp58_ = _p_it;
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp59_ = gee_iterator_next (_tmp58_);
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (!_tmp59_) {
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					break;
#line 4264 "PlaybackManager.c"
				}
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp60_ = _p_it;
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp61_ = gee_iterator_get (_tmp60_);
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				p = (NoiseEqualizerPreset*) _tmp61_;
#line 602 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp63_ = p;
#line 602 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (_tmp63_ != NULL) {
#line 4276 "PlaybackManager.c"
					NoiseMedia* _tmp64_;
#line 602 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp64_ = self->priv->_current_media;
#line 602 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp62_ = _tmp64_ != NULL;
#line 4282 "PlaybackManager.c"
				} else {
#line 602 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp62_ = FALSE;
#line 4286 "PlaybackManager.c"
				}
#line 602 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (_tmp62_) {
#line 4290 "PlaybackManager.c"
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp65_;
					const gchar* _tmp66_;
					gchar* _tmp67_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp68_;
					const gchar* _tmp69_;
					const gchar* _tmp70_;
					gchar* _tmp71_;
					gboolean _tmp72_ = FALSE;
					const gchar* _tmp73_;
					const gchar* _tmp74_;
					gboolean _tmp75_;
					gboolean match_genre = FALSE;
					gboolean _tmp79_ = FALSE;
					gboolean _tmp80_ = FALSE;
					gboolean _tmp81_;
#line 603 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp65_ = p;
#line 603 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp66_ = _tmp65_->name;
#line 603 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp67_ = g_utf8_strdown (_tmp66_, (gssize) -1);
#line 603 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					preset_name = _tmp67_;
#line 604 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp68_ = self->priv->_current_media;
#line 604 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp69_ = noise_media_get_genre (_tmp68_);
#line 604 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp70_ = _tmp69_;
#line 604 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp71_ = g_utf8_strdown (_tmp70_, (gssize) -1);
#line 604 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					media_genre = _tmp71_;
#line 606 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp73_ = media_genre;
#line 606 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp74_ = preset_name;
#line 606 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp75_ = string_contains (_tmp73_, _tmp74_);
#line 606 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp75_) {
#line 606 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp72_ = TRUE;
#line 4336 "PlaybackManager.c"
					} else {
						const gchar* _tmp76_;
						const gchar* _tmp77_;
						gboolean _tmp78_;
#line 606 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp76_ = preset_name;
#line 606 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp77_ = media_genre;
#line 606 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp78_ = string_contains (_tmp76_, _tmp77_);
#line 606 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp72_ = _tmp78_;
#line 4349 "PlaybackManager.c"
					}
#line 606 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					match_genre = _tmp72_;
#line 608 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp81_ = automatic_enabled;
#line 608 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp81_) {
#line 4357 "PlaybackManager.c"
						gboolean _tmp82_;
#line 608 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp82_ = match_genre;
#line 608 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp80_ = _tmp82_;
#line 4363 "PlaybackManager.c"
					} else {
#line 608 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp80_ = FALSE;
#line 4367 "PlaybackManager.c"
					}
#line 608 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp80_) {
#line 608 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp79_ = TRUE;
#line 4373 "PlaybackManager.c"
					} else {
						gboolean _tmp83_ = FALSE;
						gboolean _tmp84_;
#line 609 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp84_ = automatic_enabled;
#line 609 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						if (!_tmp84_) {
#line 4381 "PlaybackManager.c"
							NoiseEqualizerPreset* _tmp85_;
							const gchar* _tmp86_;
							const gchar* _tmp87_;
#line 609 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp85_ = p;
#line 609 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp86_ = _tmp85_->name;
#line 609 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp87_ = selected_preset;
#line 609 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp83_ = g_strcmp0 (_tmp86_, _tmp87_) == 0;
#line 4393 "PlaybackManager.c"
						} else {
#line 609 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							_tmp83_ = FALSE;
#line 4397 "PlaybackManager.c"
						}
#line 609 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_tmp79_ = _tmp83_;
#line 4401 "PlaybackManager.c"
					}
#line 608 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					if (_tmp79_) {
#line 4405 "PlaybackManager.c"
						{
							gint i = 0;
#line 611 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
							i = 0;
#line 4410 "PlaybackManager.c"
							{
								gboolean _tmp88_ = FALSE;
#line 611 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								_tmp88_ = TRUE;
#line 611 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
								while (TRUE) {
#line 4417 "PlaybackManager.c"
									gint _tmp90_;
									NoisePlayback* _tmp91_;
									gint _tmp92_;
									NoiseEqualizerPreset* _tmp93_;
									gint _tmp94_;
									gint _tmp95_;
#line 611 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									if (!_tmp88_) {
#line 4426 "PlaybackManager.c"
										gint _tmp89_;
#line 611 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										_tmp89_ = i;
#line 611 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										i = _tmp89_ + 1;
#line 4432 "PlaybackManager.c"
									}
#line 611 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp88_ = FALSE;
#line 611 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp90_ = i;
#line 611 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									if (!(_tmp90_ < 10)) {
#line 611 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
										break;
#line 4442 "PlaybackManager.c"
									}
#line 612 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp91_ = self->player;
#line 612 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp92_ = i;
#line 612 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp93_ = p;
#line 612 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp94_ = i;
#line 612 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									_tmp95_ = noise_equalizer_preset_getGain (_tmp93_, _tmp94_);
#line 612 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
									noise_playback_set_equalizer_gain (_tmp91_, _tmp92_, _tmp95_);
#line 4456 "PlaybackManager.c"
								}
							}
						}
#line 614 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_free0 (media_genre);
#line 614 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_free0 (preset_name);
#line 614 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (p);
#line 614 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (_p_it);
#line 614 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_free0 (selected_preset);
#line 614 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						_g_object_unref0 (equalizer_settings);
#line 614 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
						return;
#line 4474 "PlaybackManager.c"
					}
#line 602 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_free0 (media_genre);
#line 602 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_g_free0 (preset_name);
#line 4480 "PlaybackManager.c"
				}
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_g_object_unref0 (p);
#line 4484 "PlaybackManager.c"
			}
#line 601 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_g_object_unref0 (_p_it);
#line 4488 "PlaybackManager.c"
		}
#line 579 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_free0 (selected_preset);
#line 4492 "PlaybackManager.c"
	}
	{
		gint i = 0;
#line 620 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		i = 0;
#line 4498 "PlaybackManager.c"
		{
			gboolean _tmp96_ = FALSE;
#line 620 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			_tmp96_ = TRUE;
#line 620 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
			while (TRUE) {
#line 4505 "PlaybackManager.c"
				gint _tmp98_;
				NoisePlayback* _tmp99_;
				gint _tmp100_;
#line 620 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (!_tmp96_) {
#line 4511 "PlaybackManager.c"
					gint _tmp97_;
#line 620 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					_tmp97_ = i;
#line 620 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					i = _tmp97_ + 1;
#line 4517 "PlaybackManager.c"
				}
#line 620 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp96_ = FALSE;
#line 620 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp98_ = i;
#line 620 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				if (!(_tmp98_ < 10)) {
#line 620 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
					break;
#line 4527 "PlaybackManager.c"
				}
#line 621 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp99_ = self->player;
#line 621 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				_tmp100_ = i;
#line 621 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
				noise_playback_set_equalizer_gain (_tmp99_, _tmp100_, 0);
#line 4535 "PlaybackManager.c"
			}
		}
	}
#line 623 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (equalizer_settings);
#line 623 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return;
#line 4543 "PlaybackManager.c"
}


void noise_playback_manager_stop_playback (NoisePlaybackManager* self) {
	NoisePlayback* _tmp0_;
	gint64 was_playing = 0LL;
	NoiseMedia* _tmp1_;
	NoiseSettingsMain* _tmp5_;
	NoiseSettingsMain* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gint64 _tmp11_;
#line 626 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 627 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 627 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_pause (_tmp0_);
#line 628 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, FALSE);
#line 630 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	was_playing = (gint64) 0;
#line 631 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_media;
#line 631 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp1_ != NULL) {
#line 4570 "PlaybackManager.c"
		NoiseMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
#line 632 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_media;
#line 632 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp3_ = noise_media_get_rowid (_tmp2_);
#line 632 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 632 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		was_playing = _tmp4_;
#line 4582 "PlaybackManager.c"
	}
#line 634 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp5_ = noise_settings_main_get_default ();
#line 634 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 634 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp7_ = noise_settings_main_privacy_mode_enabled (_tmp6_);
#line 634 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp8_ = !_tmp7_;
#line 634 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (_tmp6_);
#line 634 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp8_) {
#line 4596 "PlaybackManager.c"
		NoiseSettingsMain* _tmp9_;
		NoiseSettingsMain* _tmp10_;
#line 635 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp9_ = noise_settings_main_get_default ();
#line 635 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp10_ = _tmp9_;
#line 635 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_settings_main_set_last_media_playing (_tmp10_, (gint64) 0);
#line 635 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (_tmp10_);
#line 4607 "PlaybackManager.c"
	}
#line 637 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_set_current_media (self, NULL);
#line 639 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp11_ = was_playing;
#line 639 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL], 0, _tmp11_);
#line 4615 "PlaybackManager.c"
}


void noise_playback_manager_start_playback (NoisePlaybackManager* self) {
	NoisePlayback* _tmp0_;
#line 642 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 643 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 643 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_play (_tmp0_);
#line 644 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, TRUE);
#line 646 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL], 0);
#line 4631 "PlaybackManager.c"
}


void noise_playback_manager_pause_playback (NoisePlaybackManager* self) {
	NoisePlayback* _tmp0_;
#line 649 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 650 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 650 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_pause (_tmp0_);
#line 651 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, FALSE);
#line 653 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL], 0);
#line 4647 "PlaybackManager.c"
}


NoiseLibrary* noise_playback_manager_get_library (NoisePlaybackManager* self) {
	NoiseLibrary* result;
	NoiseLibrariesManager* _tmp0_;
	NoiseLibrary* _tmp1_;
#line 60 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_libraries_manager;
#line 60 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = _tmp0_->local_library;
#line 60 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	result = _tmp1_;
#line 60 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 4665 "PlaybackManager.c"
}


gboolean noise_playback_manager_get_playing (NoisePlaybackManager* self) {
	gboolean result;
	gboolean _tmp0_;
#line 65 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->priv->_playing;
#line 65 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	result = _tmp0_;
#line 65 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 4680 "PlaybackManager.c"
}


static void noise_playback_manager_set_playing (NoisePlaybackManager* self, gboolean value) {
#line 65 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 65 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (noise_playback_manager_get_playing (self) != value) {
#line 4689 "PlaybackManager.c"
		gboolean _tmp0_;
#line 65 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp0_ = value;
#line 65 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		self->priv->_playing = _tmp0_;
#line 65 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		g_object_notify ((GObject *) self, "playing");
#line 4697 "PlaybackManager.c"
	}
}


gdouble noise_playback_manager_get_volume (NoisePlaybackManager* self) {
	gdouble result;
	NoisePlayback* _tmp0_;
	gdouble _tmp1_;
#line 68 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 69 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 69 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = noise_playback_get_volume (_tmp0_);
#line 69 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	result = _tmp1_;
#line 69 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 4716 "PlaybackManager.c"
}


void noise_playback_manager_set_volume (NoisePlaybackManager* self, gdouble value) {
	gdouble _tmp0_;
	NoisePlayback* _tmp1_;
	gdouble _tmp2_;
#line 71 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 72 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = value;
#line 72 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->priv->saved_volume = _tmp0_;
#line 73 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = self->player;
#line 73 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = value;
#line 73 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_set_volume (_tmp1_, _tmp2_);
#line 71 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_object_notify ((GObject *) self, "volume");
#line 4738 "PlaybackManager.c"
}


NoiseMedia* noise_playback_manager_get_current_media (NoisePlaybackManager* self) {
	NoiseMedia* result;
	NoiseMedia* _tmp0_;
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_media;
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	result = _tmp0_;
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return result;
#line 4753 "PlaybackManager.c"
}


static void noise_playback_manager_set_current_media (NoisePlaybackManager* self, NoiseMedia* value) {
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (noise_playback_manager_get_current_media (self) != value) {
#line 4762 "PlaybackManager.c"
		NoiseMedia* _tmp0_;
		NoiseMedia* _tmp1_;
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp0_ = value;
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_g_object_unref0 (self->priv->_current_media);
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		self->priv->_current_media = _tmp1_;
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		g_object_notify ((GObject *) self, "current-media");
#line 4775 "PlaybackManager.c"
	}
}


gint noise_playback_manager_get_current_index (NoisePlaybackManager* self) {
	gint result;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 158 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 159 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 159 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 159 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 159 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp2_ == 0) {
#line 4795 "PlaybackManager.c"
		gint _tmp3_;
#line 160 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp3_ = self->priv->_current_index;
#line 160 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		result = _tmp3_;
#line 160 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		return result;
#line 4803 "PlaybackManager.c"
	} else {
		gint _tmp4_;
#line 162 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp4_ = self->priv->_current_shuffled_index;
#line 162 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		result = _tmp4_;
#line 162 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		return result;
#line 4812 "PlaybackManager.c"
	}
}


void noise_playback_manager_set_current_index (NoisePlaybackManager* self, gint value) {
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 164 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 165 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 165 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 165 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 165 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (_tmp2_ == 0) {
#line 4831 "PlaybackManager.c"
		gint _tmp3_;
#line 166 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp3_ = value;
#line 166 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		self->priv->_current_index = _tmp3_;
#line 4837 "PlaybackManager.c"
	} else {
		gint _tmp4_;
#line 168 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		_tmp4_ = value;
#line 168 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		self->priv->_current_shuffled_index = _tmp4_;
#line 4844 "PlaybackManager.c"
	}
#line 164 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_object_notify ((GObject *) self, "current-index");
#line 4848 "PlaybackManager.c"
}


static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_return_if_fail (n_param_values == 2);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		data1 = closure->data;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		data2 = param_values->data[0].v_pointer;
#line 4867 "PlaybackManager.c"
	} else {
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		data1 = param_values->data[0].v_pointer;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		data2 = closure->data;
#line 4873 "PlaybackManager.c"
	}
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	callback (data1, g_value_get_int64 (param_values + 1), data2);
#line 4879 "PlaybackManager.c"
}


static GObject * noise_playback_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	NoisePlaybackManager * self;
	NoiseHistoryPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseStaticPlaylist* _tmp2_;
	NoiseStaticPlaylist* _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	NoiseStaticPlaylist* _tmp5_;
	NoiseStaticPlaylist* _tmp6_;
	GThemedIcon* _tmp7_;
#line 91 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	parent_class = G_OBJECT_CLASS (noise_playback_manager_parent_class);
#line 91 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 91 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 92 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = noise_history_playlist_new ();
#line 92 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->history_playlist);
#line 92 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->history_playlist = _tmp0_;
#line 93 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = noise_static_playlist_new ();
#line 93 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->queue_playlist);
#line 93 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->queue_playlist = _tmp1_;
#line 94 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = self->queue_playlist;
#line 94 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playlist_set_name ((NoisePlaylist*) _tmp2_, C_ ("Name of the playlist", "Queue"));
#line 95 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp3_ = self->queue_playlist;
#line 95 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_static_playlist_set_read_only (_tmp3_, TRUE);
#line 96 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp4_ = self->queue_playlist;
#line 96 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_static_playlist_set_allow_duplicate (_tmp4_, TRUE);
#line 97 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp5_ = self->queue_playlist;
#line 97 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_static_playlist_set_show_badge (_tmp5_, TRUE);
#line 98 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp6_ = self->queue_playlist;
#line 98 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp7_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
#line 98 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (((NoisePlaylist*) _tmp6_)->icon);
#line 98 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	((NoisePlaylist*) _tmp6_)->icon = (GIcon*) _tmp7_;
#line 91 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	return obj;
#line 4939 "PlaybackManager.c"
}


static void noise_playback_manager_class_init (NoisePlaybackManagerClass * klass) {
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_parent_class = g_type_class_peek_parent (klass);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_type_class_add_private (klass, sizeof (NoisePlaybackManagerPrivate));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_playback_manager_get_property;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_playback_manager_set_property;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_playback_manager_constructor;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_playback_manager_finalize;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_LIBRARY, g_param_spec_object ("library", "library", "library", NOISE_TYPE_LIBRARY, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_PLAYING, g_param_spec_boolean ("playing", "playing", "playing", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_VOLUME, g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA, g_param_spec_object ("current-media", "current-media", "current-media", NOISE_TYPE_MEDIA, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_INDEX, g_param_spec_int ("current-index", "current-index", "current-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CURRENT_CLEARED_SIGNAL] = g_signal_new ("current_cleared", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL] = g_signal_new ("queue_cleared", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_QUEUED_SIGNAL] = g_signal_new ("media_queued", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL] = g_signal_new ("media_played", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_MEDIA);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL] = g_signal_new ("playback_stopped", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL] = g_signal_new ("playback_started", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL] = g_signal_new ("playback_paused", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL] = g_signal_new ("changing_player", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL] = g_signal_new ("player_changed", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4984 "PlaybackManager.c"
}


static void noise_playback_manager_noise_player_interface_init (NoisePlayerIface * iface) {
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	noise_playback_manager_noise_player_parent_iface = g_type_interface_peek_parent (iface);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	iface->add_playback = (void (*) (NoisePlayer *, NoisePlayback*)) noise_playback_manager_real_add_playback;
#line 4993 "PlaybackManager.c"
}


static void noise_playback_manager_instance_init (NoisePlaybackManager * self) {
	GeeTreeSet* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->priv = NOISE_PLAYBACK_MANAGER_GET_PRIVATE (self);
#line 48 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_rec_mutex_init (&self->priv->__lock_playbacks);
#line 48 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp0_ = gee_tree_set_new (NOISE_TYPE_PLAYBACK, NULL, NULL, NULL, NULL, NULL);
#line 48 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->priv->playbacks = _tmp0_;
#line 51 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 51 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->priv->_current = _tmp1_;
#line 54 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 54 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->priv->_current_shuffled = _tmp2_;
#line 65 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->priv->_playing = FALSE;
#line 66 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self->priv->saved_volume = (gdouble) 1;
#line 5021 "PlaybackManager.c"
}


static void noise_playback_manager_finalize (GObject * obj) {
	NoisePlaybackManager * self;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 48 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	g_rec_mutex_clear (&self->priv->__lock_playbacks);
#line 48 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->playbacks);
#line 51 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current);
#line 54 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current_shuffled);
#line 56 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->queue_playlist);
#line 57 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->history_playlist);
#line 81 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->file_player);
#line 82 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->player);
#line 83 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current_media);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	G_OBJECT_CLASS (noise_playback_manager_parent_class)->finalize (obj);
#line 5049 "PlaybackManager.c"
}


GType noise_playback_manager_get_type (void) {
	static volatile gsize noise_playback_manager_type_id__volatile = 0;
	if (g_once_init_enter (&noise_playback_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePlaybackManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_playback_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePlaybackManager), 0, (GInstanceInitFunc) noise_playback_manager_instance_init, NULL };
		static const GInterfaceInfo noise_player_info = { (GInterfaceInitFunc) noise_playback_manager_noise_player_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_playback_manager_type_id;
		noise_playback_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "NoisePlaybackManager", &g_define_type_info, 0);
		g_type_add_interface_static (noise_playback_manager_type_id, NOISE_TYPE_PLAYER, &noise_player_info);
		g_once_init_leave (&noise_playback_manager_type_id__volatile, noise_playback_manager_type_id);
	}
	return noise_playback_manager_type_id__volatile;
}


static void _vala_noise_playback_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	switch (property_id) {
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_LIBRARY:
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		g_value_set_object (value, noise_playback_manager_get_library (self));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		break;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_PLAYING:
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		g_value_set_boolean (value, noise_playback_manager_get_playing (self));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		break;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_VOLUME:
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		g_value_set_double (value, noise_playback_manager_get_volume (self));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		break;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA:
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		g_value_set_object (value, noise_playback_manager_get_current_media (self));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		break;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX:
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		g_value_set_int (value, noise_playback_manager_get_current_index (self));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		break;
#line 5102 "PlaybackManager.c"
		default:
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		break;
#line 5108 "PlaybackManager.c"
	}
}


static void _vala_noise_playback_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
	switch (property_id) {
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_PLAYING:
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_playback_manager_set_playing (self, g_value_get_boolean (value));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		break;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_VOLUME:
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_playback_manager_set_volume (self, g_value_get_double (value));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		break;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA:
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_playback_manager_set_current_media (self, g_value_get_object (value));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		break;
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX:
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		noise_playback_manager_set_current_index (self, g_value_get_int (value));
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		break;
#line 5142 "PlaybackManager.c"
		default:
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "/builddir/build/BUILD/music-0.4.1/src/PlaybackManager.vala"
		break;
#line 5148 "PlaybackManager.c"
	}
}



